;
; bank3.asm - bank3 assembler
;
; Written by
;  Kajtar Zsolt <soci@c64.rulez.org>
;
;    This file is part of IDEDOS the IDE64 disk operating system
;    See README for copyright notice.
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
		.assert 0,0,0
BANK		= 3
;Do not use jsr $ffe4, $ffcf, $ffd2 in this bank!!!

		.include config.def
		.include makro.def
		.include consts.def
		.include external.ram
		.include internal.ram

		*= $8000

		.fill $4000,$ff

		#assert_a000romonly

		*= $a000
		.if !DE32_EXISTS
config16test	.byte $ff
		.fi
		.byte $ff,$ff,$ff
		.include crosslnk.asm

		.include console.asm
		.include dir.asm
		.include messages.asm
		.include basicwedge.asm

		#assert_a000romonly

buffer_start	.for iodhtoe=0,iodhtoe<MAX_BUFFERS,iodhtoe=iodhtoe+1
		.byte iodhtoe*8+ram_exp_buff_avail0
		.next

                #assert_cfg_open
monitor
		sei
		cld

		tax
		lda monitor_ripper_exp
		bne monitor_start.mon_rip_start
		#stx_l_a monitor_oldbank_exp

		lda $00
		sta monitor_data_exp
                .if SUPERCPU=0
		lda #255
		sta $00			;Does not work on SCPU!
                .fi
		lda $01
		sta monitor_data_exp+1
                .if SUPERCPU=1
                lda #$37
                sta $01
                .else
                lda #0
                sta $00			;Does not work on SCPU!
                .fi
		jmp monitor_start

		.include lowlevel.asm	;duplicated code!
		.include ram.asm	;duplicated code!
		.include ideserv.asm
                .include channel15_2.asm

		.include misc.asm	;duplicated code!
		.include trap.asm

                .cerror *>$9f82
;---------------------------
;Length of addressing modes
;
		#assert_8000romonly

                *= $9f82

a_len		.byte 1-1+(15)*16	  		   ;A
		.byte 2-1+(a_last_xi-a_last+1)*16+4     ;($FF,x)
		.byte 3-1+(a_last_i-a_last+1)*16+4      ;($FFFF)
		.byte 2-1+(a_last_iy-a_last+1)*16+4     ;($FF),y
		.byte 3-1+(a_last_xi-a_last+1)*16+4     ;($FFFF,x)
		.byte 4-1+(a_last_x-a_last+1)*16	   ;$FFFFFF,x
		.byte 2-1+(a_last_i-a_last+1)*16+4      ;($FF)
                .byte 2-1+(a_last_siy-a_last+1)*16+4    ;($FF,s),y
                .byte 3-1+(2)*16			   ;$FF,$FF
                .byte 2-1+(a_last_il-a_last+1)*16+8     ;[$FF]
                .byte 3-1+(15)*16			   ;$FFFF
		.byte 2-1+(a_last_ily-a_last+1)*16+8    ;[$FF],y
                .byte 2-1+(15)*16	 		   ;$FFFF
                .byte 2-1+(a_last_s-a_last+1)*16	   ;$FF,s
                .byte 1-1+(0)*16
                .byte 1-1+(0)*16
                .byte 2-1+(0)*16+12                     ;#$FF
                .byte 2-1+(0)*16+12                     ;#$FF
                .byte 2-1+(0)*16			   ;$FF
                .byte 2-1+(0)*16                        ;$FF
		.byte 2-1+(a_last_x-a_last+1)*16        ;$FF,x
		.byte 2-1+(a_last_x-a_last+1)*16	   ;$FF,x
		.byte 2-1+(a_last_y-a_last+1)*16        ;$FF,y
		.byte 2-1+(a_last_y-a_last+1)*16	   ;$FF,y
		.byte 3-1+(a_last_x-a_last+1)*16        ;$FFFF,x
		.byte 3-1+(a_last_x-a_last+1)*16    	   ;$FFFF,x
		.byte 3-1+(a_last_y-a_last+1)*16        ;$FFFF,y
		.byte 3-1+(a_last_y-a_last+1)*16	   ;$FFFF,y
                .byte 3-1+(0)*16                        ;$FFFF
                .byte 3-1+(0)*16			   ;$FFFF
                .byte 4-1+(0)*16			   ;$FFFFFF
                .byte 4-1+(0)*16			   ;$FFFFFF

		.enc screen
a_first         .byte "(","[","#"

a_last
a_last_x       	.byte ","*2,"x"*2+1

a_last_xi      	.byte ","*2,"x"*2
a_last_i       	.byte ")"*2+1

a_last_s       	.byte ","*2,"s"*2+1

a_last_il      	.byte "]"*2+1

a_last_siy     	.byte ","*2,"s"*2
a_last_iy      	.byte ")"*2
a_last_y       	.byte ","*2,"y"*2+1

a_last_ily     	.byte "]"*2,","*2,"y"*2+1
		.enc none

                .assert CFG_RAM | CFG_8000_ROM | CFG_A000_ROM | CFG_D000_IO | CFG_E000_ROM, CFG_A000_ROM,CFG_A000_RAM | CFG_A000_BASIC

billc		#jword 29,b_right
		#jword 157,b_left
		#jword 147,b_clr
		#jword 19,b_home
		#jword 3,b_stop
		#jword 20,b_del
		#jword 141,b_shret
		#jword 148,b_ins
		#jword 133,b_f1
		#jword 136,b_f7
		#jword 18,b_rvson
		#jword 146,b_rvsoff
		#jword 13,b_ret
		#jword 17,b_down
		#jword 145,b_up
		#jword 134,b_f3
		#jword 135,b_f5
		#jword 137,b_f2
		#jword 140,b_f8
billce
;---------------------------
;Peek under rom (copied $7e8)
;
		#assert_8000romioonly
mon_peek	.proc
		sta cfg_stnd		;3
		sta $01			;5
                .if SUPERCPU=1
                lda (m_p2)
                .else
		lda (m_p2,x)		;7
                .fi
		ldx #$37		;9
		stx $01			;11
		sta cfg_16		;14
		rts			;15
		.pend

                .cerror *>$a000

		*= $8000

		.include mon.asm

		.cerror *>$9e60		;Bank3 block $8000-$9e60 over!
