;
; basic.asm - basic extensions
;
; Written by
;  Kajtar Zsolt <soci@c64.rulez.org>
;
;    This file is part of IDEDOS the IDE64 disk operating system
;    See README for copyright notice.
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
;**************************************************
;Basic extensions
;
;Listing does not have problems.
;Tokenizer may have problems with irq $8000-$9fff or turned off basic...
;Token executor may have problems with irq $8000-$9fff or turned off basic...
;**************************************************
;---------------------------
;LIST modification (cfg_open)
;
		#assert_cfg_open
OP_mylist	.proc
		cmp #$cc		;first undefined token
		bcc listback
		cmp #$ff		;PI
		beq listback		;C=0
		bit $0f			;" mode
		bmi listback
listbank0	.proc
		sec
		sbc #$f0		;Our codes from $f0
		sta $49
		ldx #$ff
next		dec $49
		bmi print
loop		inx
		lda newcommands,x
		bpl loop
		gmi next

printlp		jsr newchrout_t		; chrout (cfg_16)
print		inx
		lda newcommands,x
		bpl printlp

end		and #$7f

listback       	.proc
		sta $49
		#psr $a71a
		lda $49
		jmp switch_norm
		.pend
;---------------------------
;Hex, oct, and bin numbers
;
		#assert_cfg_open
OP_myexpr	.proc
		#assert_basic_kernalio
basic_bd7e	= $bd7e
		#assert_cfg_open

                #sta_cfg_16
                #stz_a $0d
                jsr newchrget
                eor #"$"
                cmp #3
                bcc ok
                #psr $ae8d
end             jsr newchrgot
                jmp exit2basic

al		.byte 4,1,3

ok      	tax
		lda al,x
		sta $45

                #lda0
		ldx #10
rp              sta $5d,x
                dex
                bpl rp

oeu		jsr newchrget
                bcc num
                ldx $45
                cpx #4
                bcc ndef
                cmp #$f2
                bne ndef1
                ldy #$c
                jsr num2
                lda #"d"
ndef1           cmp #$96
                bne ndef
                ldy #$d
                jsr num2
                ldy #$e
                jsr num2
		lda #"f"
ndef            cmp #"a"
                bcc end
                sbc #8
num		sbc #47
                tay
		ldx $45
rpu             lsr
                dex
		bne rpu
                tax
                bne end
		jsr num2
                #jmps oeu

num2            lda $61
                beq r
                clc
                adc $45
                bcs over
                sta $61
r		tya
		sta cfg_8
                #assert_cfg_8
                jsr basic_bd7e
                sta cfg_16
                #assert_cfg_16
                rts

over		lda #11			;syntax error
		jmp bas_ioerror

		.pend
;---------------------------
;New BASIC keywords
;
		#assert_8000romonly
newcommands	.proc
		.shift "ll"		;$f0
		.shift "dir"		;$f1
		.shift "cd"		;$f2
		.shift "rm"		;$f3
		.shift "mkdir"		;$f4
		.shift "hdinit"		;$f5
		.shift "kill"		;$f6
		.shift "init"		;$f7
		.shift "change"		;$f8
		.shift "date"		;$f9
		.shift "man"		;$fa
		.byte 0
		.pend
;---------------------------
;Tokenizer modification (cfg_8)
;Always tokenizes from buffer $200
;
;@ <- * *(toketized?) " RVSON? / /(tokenized) % ^ ^(tokenized) ' Font
;
		#assert_8000romonly
tokencmd	.proc
		.text "#"
                .text '"'^"#"
		.text "@"^'"'
                .text "/"^"@"
                .text "%"^"/"
                .text 94^"%"
                .text 95^94
                .text 39^95
                .text 92^39
                .text "."^92
                .text "*"^".";* not implemented
		.pend			;but needed for JiffyDos...

		#assert_cfg_open
LW_mytoken	.proc
		ldy #4
		inx
		bne notdirectmode	;in program line mode...
lp		eor tokencmd,x
                beq ide
		inx
                cpx #11
		bcc lp

notdirectmode	sta cfg_8
                #assert_cfg_8

		ldx $7a
                sty $0f

nextchr         lda $200,x
                bpl normal
                cmp #$ff		;pi
                beq jo
                inx
                gne nextchr

normal		cmp #$20
		beq jo
                sta $08
                cmp #'"'      		;"
                beq getchr
                bit $0f
                bvs jo
                cmp #"?"
                bne sk
                lda #$99		;print
                gne jo

sk		cmp #"0"
		bcc sk1
                cmp #"<"
                bcc jo			;0123456789:
sk1		sty $71
		ldy #0
                sty $0b
                stx $7a

                .byte SKIP2

cmpl            iny
                inx

tnxtcmd         lda $200,x
                eor $a09e,y
                beq cmpl
                cmp #$80
                bne nxtcmd
jo3             ora $0b

jo2             ldy $71

jo		inx
		iny
                sta $1fb,y
                cmp #0
                beq endd
                sbc #":"
                beq sk2
                cmp #$83-":"		;data
                bne sk3

sk2		sta $0f
sk3		eor #$8f-":"		;rem
                bne nextchr
                .byte SKIP1BNE
                #assert_8000romonly
ide             tax
		sta $08
                .assert CFG_RAM | CFG_8000_ROM | CFG_A000_BASIC | CFG_D000_IO | CFG_E000_ROM, CFG_RAM | CFG_8000_ROM | CFG_A000_BASIC | CFG_D000_IO | CFG_E000_ROM, CFG_OPEN_RAM | CFG_8000_RAM | CFG_A000_RAM | CFG_A000_ROM | CFG_D000_ROM | CFG_E000_OPEN

reml            lda $200,x
                beq jo
                cmp $08
                beq jo
getchr          iny
                sta $1fb,y
                inx
                gne reml

nxtcmd		ldx $7a
		inc $0b

sf              iny
                lda $a09e-1,y
                bpl sf
                lda $a09e,y
                bne tnxtcmd

                tay
                lda #$f0
                sta $0b
                .byte SKIP2
cmpl2           iny
                inx

tnxtcmd2        lda $200,x
                eor newcommands,y
                beq cmpl2
                cmp #$80
                beq jo3

		ldx $7a
		inc $0b

sf2             iny
                lda newcommands-1,y
                bpl sf2
                lda newcommands,y
                bne tnxtcmd2

                lda $200,x
                bpl jo2
                #assert_8000romioonly
endd            sta $1fd,y
                dec $7b
                lda #$ff
                sta $7a
		gne emptycommand
		.pend
;---------------------------------------
;Token executor modification (cfg_16)
;---------------------------------------
		#assert_kernal_io
kernal_setnam   = $ffbd
                #assert_cfg_16
myopen		.proc
                .if SUPERCPU=1
                beq myclose.s
		#psr $e1c1
                bra myclose.in
                .else
                bne myclose.in
                .fi
                .pend

myclose		.proc
s               beq syntaxe
                .if SUPERCPU=1
		#psr $e1ca
in
		.else
                ldx #<($e1ca-1)
                .byte SKIP2
in              ldx #<($e1c1-1)
                lda #>($e1ca-1)
                pha
                txa
                pha
                .fi
		#stz_a ActualFNLength
                jsr far_b79e		;cfg_16 after
                #assert_cfg_16
                stx $49
                #psr $e229
                txa
                ldx ActualDev
                #jmps emptycommand
                .pend

myload		.proc
		#lda0
		.byte SKIP2
myverify       	.proc
		lda #1
		sta $0a
		sta ActualSecAddr

		#psr $e16f

                lda ActualDev
                cmp #2
                #lda0
                rol
		ldx #<$e1b3
		ldy #>$e1b3
mylosaback	.proc
		jsr kernal_setnam		;"*" as default filename (from kernal rom)

		#psr $e1e0
		#jmps emptycommand
		.pend

mysave		.proc
		#psr $e159
		#lda0
		sta ActualSecAddr
		geq mylosaback
		.pend

		#assert_8000romioonly
emptycommand	.proc
		jmp exit2basic
		.pend

                #assert_cfg_16
myif		.proc
		jsr cad9e		;cfg_16
		jsr newchrgot		;otherwise there will be some problems in $8000-
                cmp #$89		;goto?
		beq ifgoto		;C=1
		eor #$a7		;then?
		bne syntaxe
		jsr newchrget		;C=0 if number
ifgoto		lda $61
		bne ifthen
		#psr $a93b		;rem rest of line
		#jmps emptycommand

cad9e		#psr switch_16k
		#psr $ad9e
		#jmps emptycommand

ifthen		jsr newchrgot
		bcs mydoit
                .if SUPERCPU=0
                tax
                .fi
		#psr $a8a0		;goto xxx
                .if SUPERCPU=0
                txa
                .fi
		gcc emptycommand
;----
                #assert_cfg_16
mydoit		.proc
		beq emptycommand
		asl
		bcc nottoken
		cmp #$23+$23
		bcs overt
		tay
hackedb2	.proc
		lda basic_keyw+1,y
		bpl hackedb
		pha
		lda basic_keyw,y
		pha
		jmp basexeccmd

nottoken	.proc
		lsr
		ldx #$00
		stx $0c
		sta $45
		cmp #"a"
		bcc mymisc
		cmp #1+"z"
		bcs mymisc
		gcc basnottoken
                .pend

hackedb		.proc
		ora #$80
		pha
		lda basic_keyw,y
		gcc tulin

mymisc		.proc
		tax
                .if SUPERCPU=0
		#sta_cfg_open
		lda JiffyDos_present_exp
		beq dud
                .fi
                #lda0
                cpx #"@"		;@# hack
                bne dud
                ldx $7a
                ldy $7b
		#sta_cfg_16
                jsr newchrget
		#sta_cfg_open
                stx $7a
                sty $7b
                ldx #"@"
                cmp #"#"
                bne dud
                lda #CMOS_DOS_WEDGE
dud     	ora setup_atribut_exp
		#sta_cfg_16
		and #CMOS_DOS_WEDGE
		beq syntaxe2
   		txa
		ldy #$e6
-		eor tokencmd-$e6,y
		beq jmpu
		iny
		cpy #$f0
		bne -
syntaxe2	#psr $a9a8
		.byte SKIP1

syntaxe		.proc
		tax
		#psr $af08
		txa
		jmp exit2basic
                .pend

syntaxek        cmp #$2e+$2e            ;^
                beq +
		cmp #$2d+$2d            ;/
                bne syntaxe
+               ldy #$e9

jmpu		.proc
		tya
		asl
		gcs overt.jht

overt		.proc
		cmp #$4b+$4b		;GO?
		bne notgo
		#psr $a812
		jmp exit2basic

notgo		cmp #$e0		;>$f0
		bcc syntaxek
                cmp #$f6		;<$fb
                bcs syntaxe

jht		tay
		#psr exit2basic
		lda basic_keyw.insad-$df,y
		pha
		lda basic_keyw.insad-$e0,y

tulin		.proc
		pha
		jmp newchrget		;start in cfg_16
                .pend

                #assert_cfg_16
mydef		.proc
		cmp #$a5		;fn
		bne py

                #psr $b3b3
                #assert_8000romioonly
ti              jmp exit2basic

		#assert_8000romioonly
py		#sta_cfg_open
		lda #8
                sta $ae
                #lda0
                sta $af
                tax
jc              sta function_keys_exp,x
                inx
                bpl jc

		#assert_8000romioonly
te              ldx #<($e257-1)
                ldy #>($e257-1)
                jsr far			;cfg_16 after
                #assert_cfg_16

                jsr getfilename		;cfg_open after
                #assert_cfg_open

                ldx $af
                bmi ex
                ldy #0
tp              #lda_l_y_ path_exp
		sta function_keys_exp,x
                inx
                bmi ex
                eor #0
                beq ex
                eor #13
                beq ex
                iny
                gne tp

ex		stx $af

                dec $ae
                beq ti

                ldx #<($e20e-1)
                ldy #>($e20e-1)
                jsr far			;cfg_16 after
                #assert_cfg_16

                #jmps te
		.pend

                #assert_cfg_16
mysys		.proc
                ldx #<($ad8a-1)
                ldy #>($ad8a-1)
                jsr far			;cfg_16 after
                #assert_cfg_16
                ldx #<($b7f7-1)
                jsr far_b7			;cfg_16 after
                #assert_cfg_16
                #psr $e147
                lda $14
                ora $15
                bne sr
                .if SUPERCPU=1
                plx
                #psr $4721
                .if BANK
		lda #BANK
                .fi
                .else
                pla
                #psr $4721
		lda #BANK
                .fi
                pha
                pha
                pha
                #sta_cfg_open
		jmp monitor

		#assert_cfg_16
sr
                ldy #$fc
thp             #phy_a
		jsr newchrgot
                beq nom
                cmp #";"
                bne nom
                jsr newchrget
                cmp #";"
                bcs nom
                jsr far_b79e			;cfg_16 after
                #assert_cfg_16
                sec
                .byte SKIP1BCC
nom		clc
		#ply_a
                txa
                bcc ee
                sta $30c-$fc,y
ee              iny
		bne thp
		#psr $e136
                jmp exit2basic
 		.pend

		.assert CFG_RAM | CFG_8000_ROM | CFG_A000_ROM | CFG_D000_IO | CFG_E000_ROM, CFG_8000_ROM, CFG_8000_RAM
basic_keyw	.proc
		.rta $A831,$A742,$AD1E,$A8F8;$80
		.rta $ABA5,$ABBF,$B081,$AC06;$84
		.rta $A9A5,$A8A0,$A871,myif-$8000;$88
		.rta $A81D,$A883,$A8D2,$A93B;$8c
		.rta $A82F,$A94B,$B82D,myload-$8000;$90
		.rta mysave-$8000,myverify-$8000,mydef-$8000,$B824;$94
		.rta $AA80,$AAA0,$A857,$A69C;$98
		.rta $A65E,$AA86,mysys-$8000,myopen-$8000;$9c
		.rta myclose-$8000,$AB7B,$A642

					;           ,<$BC39 ;$a0
					;          .byte <$BCCC,<$BC58,<$0310,<$B37D ;$a4
					;         .byte <$B39E,<$BF71,<$E097,<$B9EA ;$a8
					;        .byte <$BFED,<$E264,<$E26B,<$E2B4 ;$ac
					;       .byte <$E30E,<$B80D,<$B77C,<$B465 ;$b0
					;      .byte <$B7AD,<$B78B,<$B6EC,<$B700 ;$b4
					;     .byte <$B72C,<$B737

		.rta basshell		;11 #    $e6
                .rta baserrorchannel	;12 "    $e7
		.rta baserrorchannel	;13 @    $e8
		.rta basloadfile0	;14 /    $e9
		.rta basloadfile1	;15 %    $ea
		.rta basloadfile2	;16 ^    $eb
		.rta bassavefile0	;17 <-   $ec
		.rta basverifyfile0	;18 '    $ed
		.rta basloadfile3	;19 font $ee
		.rta bascdfile		;20 .    $ef
insad		.rta basll		;0       $f0
		.rta basdir		;1       $f1
		.rta bascd		;2       $f2
		.rta basdelete		;3       $f3
		.rta basmkdir		;4       $f4
		.rta bashdinit		;5       $f5
		.rta baskill		;6       $f6
		.rta basinit		;7       $f7
		.rta baschange		;8       $f8
		.rta basdate		;9       $f9
		.rta manager		;10      $fa
		.pend
;---------------------------------------
;Basic INIT (fills memory with 0 & softreset)
;---------------------------------------
                #assert_cfg_16
basinit		.proc
                php
                jsr clallx
                plp
		beq te
                jsr far_b79e			;cfg_16 after
                #assert_cfg_16
                .byte SKIP2
te              ldx #0
		sei
		lda #$7f
		sta $dd0d
-		lda $d011
		bpl -
		and #%11101111
		sta $d011
		ldy #endfill-filler
loop		lda filler-1,y
		sta $01,y
		dey
		bne loop
                txa
		ldx #$2f
		stx $00
		ldx #$33
		jmp $02			;START !!!
;--------------------------------------
filler		.logical $0002
		stx $01
lp		sta $0100,y
		sta $8000,y
		iny
		bne lp
		inc lp+2
		inc lp+5
		bne lp
                .if SUPERCPU=1
                lda #$37
                .else
		sta $00			;Does not work on SCPU!
                .fi
		sta $01
		jmp cart_reset		;!!!!!!
		.here
endfill 	.pend
;---------------------------------------
;Basic HDINIT
;---------------------------------------
                #assert_8000romonly
mastertxt      	.null "master:",13
slavetxt      	.null "slave:",13
		.if DRIVES=4
pritxt          .null "primary "
sectxt          .null "secondary "
                .fi

                #assert_cfg_16
bashdinit	.proc
                jsr clallx
		#sta_cfg_open
		jsr OP_save_zeropage
		jsr OP_kill_drives

		.if DRIVES=4
                sta select0_g
                jsr resetbus
                sta select1_g
                .fi
                jsr resetbus

		ldx #0
jf              jsr wait_a_bit
                dex
                bne jf

		#lda0
cuc             pha
		.if DRIVES=4
		cmp #2
                bne xex
		#sta_low_reg
                sta cyllow_g
xex
                .fi
		jsr LWOP_hdinit
                bcs g
		bit msgmode
		bpl g

                pla
                pha
		lsr
                .if DRIVES=4
                php
                lsr
                lda #<pritxt
                ldy #>pritxt
                bcc +
                lda #<sectxt
                .if (>sectxt)!=(>pritxt)
                ldy #>sectxt
                .fi
+               jsr LWNO_print_ay
                plp
                .fi
                lda #<mastertxt
                ldy #>mastertxt
                bcc +
                lda #<slavetxt
                .if (>slavetxt)!=(>mastertxt)
                ldy #>slavetxt
                .fi
+               jsr LWNO_print_ay
		ldx #216
		clv
lp		php
		#sta_cfg_open
		lda ident_model_number_exp-216,x
		bmi inval
		cmp #32			;skip control chars
		bge +
inval		lda #32
+		cmp #97
		blt +
		sbc #32
+               plp
                cmp #32
                bne ni
                sbc #$a0		;set v
                gvs iy

ni              bvc nx
		pha
                jsr basll.print_space
                pla
                clv
nx            	php
		jsr newchrout_t		; chrout (cfg_16)
                dey
                plp
iy		inx
		bne lp
                jsr basll.print_cr
		#sta_cfg_open
g
                pla
                #adc1c
                cmp #DRIVES
                bcc cuc

		#lda0
cec     	pha
		jsr OP_XIT_hdinit_2
                jsr transfer_test
                jsr OP_get_current_drive_type
                ror
                sta drive_hwproblems_exp,x

              	pla
                #adc1c
                cmp #DRIVES
                bcc cec
		jsr OP_hdinit_drivenumbers
		jmp OP_restore_zeropage

resetbus       	lda #%00000110		;SRST drives
		jsr cd
		lda #%00000010
cd		#sta_low_reg
		sta contr_g
		jmp wait_a_bit		;>5us
		.pend
                #assert_8000romioonly

clallx          #psr switch_16k
		jmp __clall		;newclall_t
;---------------------------------------
;Basic KILL (switches off cartridge)
;---------------------------------------
                #assert_cfg_16
baskill		.proc
                tay
		lda ActualDev
		pha
                jsr clallx
		cpy #"!"
                bne tt
		#sta_cfg_open
		#lda0
ere		pha
                tax
                lda drive_type_exp,x
                beq next
		lda current_hdd_exp,x
		beq next
                sta ActualDev
                txa
                lsr
                tax
                lda setup_powerman_exp,x
                bcs kd
                asl
                asl
                asl
                asl
kd		cmp #$20
		bcc next
                ldx #<off
                ldy #>off
                jsr bas_open15commandc
                jsr bas_close
next            pla
                #adc1c
                cmp #DRIVES
                bcc ere
		#sta_cfg_16
tt		sei
		pla
		sta ActualDev
		jsr LWNO_set_old314vect
                jsr exit_c128key
		jsr LWNO_basic_restore
		#sta_cfg_open
		ldx #endexit-exiter
loop		lda exiter-1,x
		sta $1ff,x
		dex
		bne loop
		jsr LWNO_print_imediate	;cfg_16
		.null "bye!",13
                #assert_cfg_16
		lda #1
		jmp $200		;START !!!

                #assert_8000romonly
off		.null "u0>p0"
;--------------------------------------
                #assert_8000romioonly
exiter		sta cfg_stnd
		sta kill_port
		jmp ($a002)
endexit		.pend
;---------------------------------------
;Basic DATE (prints date and time)
;---------------------------------------
		#assert_cfg_16
basdate		.proc
                jsr bas_optional_devnum

                ldx #<tra
                ldy #>tra
                jsr bas_open15commandc
                #jmps baserrorchannel.errinlp

tra		.null "t-ra"
;---------------------------------------
;Basic @ (Read error channel)
;---------------------------------------
		#assert_cfg_16
baserrorchannel	.proc
		cmp #"#"
		bne noch
                ldx #<($b79b-1)
                jsr far_b7			;cfg_16 after
                #assert_cfg_16
		txa
		jsr bas_devcheck.in
		stx ActualDev
                .if SUPERCPU=0
                #sta_cfg_open
		lda JiffyDos_present_exp
                #sta_cfg_16
		beq n
                .fi
		stx $be			;Jiffydos...
n               cpx #4
		bcc +

                #lda0
		sta ActualSecAddr
                sta ActualFNLength
                jsr bas_open_common
                jsr bas_close
                lda #KERNAL_DEVICE_NOT_PRESENT
                bit Status
                bmi bas_ioerror
+               rts

noch		jsr calcfnlength
                jsr getfilename		;cfg_open after
                #assert_cfg_open
                lda path_exp
		eor #"$"
		bne noch2
		jsr tryopenfile
                .assert CFG_8000_ROM | CFG_A000_ROM | CFG_D000_IO,CFG_8000_ROM | CFG_A000_ROM | CFG_D000_IO, CFG_8000_RAM | CFG_A000_RAM | CFG_A000_BASIC | CFG_D000_ROM
dir     	jsr bas_xchrin          ;Skip load address
		#assert_cfg_16
	     	jsr bas_xchrin          ;Skip load address
lp		jsr bas_xchrin		;Skip linking
		jsr bas_xchrin		;Skip linking
		jsr basll.print_cr
		jsr bas_xchrin		;Filesize
                tax
		jsr bas_xchrin		;Filesize
		jsr printaxnum		;Print size
		lda #32
-		jsr newchrout_t		;Print name
		jsr bas_xchrin
		tax
		bne -
		jsr check_stop		;Stop?
		bne lp
		geq bcl

		#assert_8000romioonly
tryopenfile	sta ActualSecAddr
		jsr bas_devcheck
		jmp bas_open

noch2		lda #15
		jsr tryopenfile	        ;Exec command
                .assert CFG_8000_ROM | CFG_A000_ROM | CFG_D000_IO,CFG_8000_ROM | CFG_A000_ROM | CFG_D000_IO, CFG_8000_RAM | CFG_A000_RAM | CFG_A000_BASIC | CFG_D000_ROM
errinlp		jsr newchrin_t		;Print error channel
		ldx Status
		jsr newchrout_t
		txa
		beq errinlp
bcl             #jmps bas_close
		.pend
;---------------------------
;Calculate filename length and position for BASIC wedge commands
;
		#assert_cfg_16
calcfnlength	.proc
		lda $7a
                sta ActualFilename
		lda $7b
		sta ActualFilename+1
                jsr newchrgot
                #jmps xx

lp		jsr newchrget
xx              tay
		beq dxb
                cmp #'"'
                bne lp

                ldx #<($e257-1)
                ldy #>($e257-1)
                jsr far			;cfg_16 after
                #assert_cfg_16
                jsr newchrgot
                beq ti
                cmp #","
                bne ti
                ldx #<($e200-1)
                ldy #>($e200-1)
                jmp bas_optional_devnum.in

dxb		lda $7a
		sec
		sbc ActualFilename
                sta ActualFNLength
ti		rts
		.pend
;---------------------------
;Kill rest of basic line
;
calcfnlength_eatg
		jsr calcfnlength
                #jmps eatg

eatglp		jsr newchrget		;otherwise there will be some problems in $8000-
eatg		sta cfg_16
                #assert_cfg_16
		jsr newchrgot		;otherwise there will be some problems in $8000-
;		cmp #0
		bne eatglp
		rts
;---------------------------
;Print decimal number in A/X
;
printanumper	tax
		lda #"/"
                .byte SKIP2
printxnumsp     lda #32
		jsr newchrout_t
                #assert_cfg_16
printxnum	.proc
		#lda0
                #assert_cfg_16
printaxnum	.proc
		tay
		#sta_cfg_open
                .if SUPERCPU=0
                lda #>(switch_16k-1)
                pha
                .fi

		lda buffer_output_exp
		eor #STDOUT
		bne nonstandard
		lda buffer_input_exp
		cmp #STDIN
		bne nonstandard
                .if SUPERCPU=1
		#psr gotobank3back
		gcs standard

nonstandard	#psr switch_16k
standard
                .else
		lda #<(gotobank3back-1)
                .byte SKIP2
nonstandard    	lda #<(switch_16k-1)
                pha
                 .fi
		#psr $bdcd
		tya
		jmp exit2basic
		.pend
;---------------------------------------
;Basic shell
;---------------------------------------
                #assert_cfg_16
basshell	.proc
		ldx $3a
                inx
                bne OP_myexpr.over

		ldx #6
		stx ActualFNLength
ve		lda bf-1,x
		sta @w$ff,x
		dex
		bne ve
		stx ActualFilename
		inx
		stx ActualSecAddr
                stx $14
		stx ActualFilename+1
                #sta_cfg_open
                lda ActualDev
                sta $ff

                lda setup_boot_drive_exp
		sta ActualDev
                lda #$80
                sta load_autostart_exp

                asl
                sta msgmode		;clear messages
                gcs sh

                #assert_8000romonly

bf		.text "1//:sh"
		.pend
;---------------------------------------
;Basic / % ^ ' (load file)
;---------------------------------------
                #assert_cfg_16
basloadfile3	.proc			;font
		lda #$80
		#sta_cfg_open
		sta load_autostart_exp
		#sta_cfg_16
		gne basloadfile1
		.pend

basloadfile2	.proc			;^
		lda #1
		#sta_cfg_open
		sta load_autostart_exp
		#sta_cfg_16
		gne basloadfile0
		.pend

basverifyfile0	lda #1			;'
		tax
		gne basloadin
basloadfile1	ldx #1			;%
		.byte SKIP2
basloadfile0	ldx #0			;/
		#lda0
basloadin	stx ActualSecAddr
		stx $14
		pha
		jsr calcfnlength_eatg
                pla
                #assert_8000romioonly
sh              sta $0a
                pla
		pla
                jsr loadx		;newload_t
                #assert_cfg_16
                bcs err
                lda $0a
                beq load
                lda Status
                and #$10
                bne err2
                #psr $e18d
                #jmps exit2basicx

		#assert_8000romioonly
loadx		#psr switch_16k
                lda $0a
		ldx $2b
                ldy $2c
		stx $c3
		sty $c4
                jmp __load		;newload_t

                #assert_cfg_16

load		lda Status
		and #$bf
                bne err3
                #sta_cfg_open
		lda load_autostart2_exp	;autostart?
		bpl tp
                lda load_autostart_start_exp
                cmp #1
		lda load_autostart_start_exp+1
		sbc #0
		pha
                lda load_autostart_start_exp
                sec
                sbc #1
		pha
tp              #sta_cfg_16

                lda $14
                bne exit2basicx
                #psr $e1a1
                #jmps exit2basicx

err3		lda #$1d	;load error
		.byte SKIP2
err2		lda #$1c	;verify error
err		jmp bas_ioerror

bassavefile0	.proc
		#stz_a ActualSecAddr
		jsr calcfnlength_eatg
                pla
                pla
		#psr $e159

exit2basicx	.proc
		jmp exit2basic
		.pend

bascdfile	.proc
tmp		=$ae
		jsr calcfnlength_eatg
		ldx #<bascd.cdtxt
		ldy #>bascd.cdtxt
                stx tmp
                sty tmp+1
		jsr bas_common.in
                #jmps bascd.in2
                .pend
;---------------------------------------
;Basic LL and DIR common stuff
;---------------------------------------
dir_common     	.proc
tmp		=$ae
		ldx #<dirtxt
		ldy #>dirtxt
		stx tmp
		sty tmp+1
		jsr bas_optional_name_and_devnum
                #jmps bas_common.in

dirtxt		.null "$"
;---------------------------------------
;Basic CD, MKDIR and RM common stuff
;---------------------------------------
		.assert CFG_RAM | CFG_8000_ROM | CFG_A000_ROM | CFG_D000_IO | CFG_E000_ROM, CFG_RAM | CFG_8000_ROM | CFG_A000_ROM | CFG_D000_IO | CFG_E000_ROM, CFG_OPEN_RAM |  CFG_8000_RAM | CFG_A000_RAM | CFG_A000_BASIC | CFG_D000_ROM | CFG_E000_OPEN
bas_common	.proc
tmp		=$ae
		stx tmp
		sty tmp+1
		jsr bas_required_name_and_devnum
                .assert CFG_8000_ROM | CFG_A000_ROM | CFG_D000_IO, CFG_8000_ROM | CFG_A000_ROM | CFG_D000_IO, CFG_8000_RAM | CFG_A000_RAM | CFG_A000_BASIC | CFG_D000_ROM
in              jsr getfilename		;cfg_open after
                #assert_cfg_open
		#jmps bas_commandc.in
;---------------------------------------
;Common command stuff
;---------------------------------------
		#assert_8000romioonly
bas_commandc	.proc
tmp		=$ae
		stx tmp
		sty tmp+1
		#lda0
                #sta_cfg_open
                sta path_exp
in              .if SUPERCPU=1
                tsc
                .else
                tsx
                txa
                .fi
                sbc #10
                bcc outm
                sta ActualFNLength
                ldy #$ff
kk              iny
		cpy ActualFNLength
                bcs outm
		lda (tmp),y
                sta $100,y
		bne kk
		tax
nnf		lda path_exp,x
                beq jo
                inx
                eor #":"
                bne nnf
                tax
                geq cx

jo              txa
		beq exu
		lda #":"
                ldx #$ff
nnu             inx
		sta $100,y
                iny
                cpy ActualFNLength
                bcs outm
cx		lda path_exp,x
		bne nnu
exu	    	tya
                ldx #<$100
                ldy #>$100
                #sta_cfg_16
                jmp kernal_setnam
                .pend

                #assert_8000romioonly
outm		#jmps bas_outofmemory
;---------------------------------------
;Basic CDOPEN
;---------------------------------------
                #assert_8000romonly
txtopen         .null "u0>e1"
txtclose        .null "u0>e0"

		#assert_cfg_16
bascdopencl   	.proc
		php
                jsr newchrget
		jsr bas_optional_devnum
		ldx #<txtopen
		ldy #>txtopen
                plp
                beq ii
                ldx #<txtclose
                .if (>txtclose)!=(>txtopen)
                ldy #>txtclose
                .fi
ii              jsr bas_open15commandc
                #jmps bas_checkerrorclose
;---------------------------------------
;Basic CD
;---------------------------------------
		#assert_cfg_16
bascd		.proc
		cmp #$a0+1	;close
                bcs dw
		cmp #$9f	;open
                bcs bascdopencl
dw
		ldx #<cdtxt
		ldy #>cdtxt
in		jsr bas_common
in2		jsr bas_open15
                jsr bas_checkerrorclose
                lda #KERNAL_FILE_NOT_FOUND
                bcs bas_ioerror
                rts
cdtxt           .null "cd"
                .pend
;---------------------------------------
;Basic RM
;---------------------------------------
		#assert_8000romonly
stxt            .null "s"
rdtxt           .null "rd"

		#assert_cfg_16
basdelete	.proc
		ldx #<stxt
                ldy #>stxt
                cmp #$f1
                bne bascd.in
                jsr newchrget
                ldx #<rdtxt
                .if (>rdtxt)!=(>stxt) | (<rdtxt)=0
                ldy #>rdtxt
                .fi
                gne bascd.in
		.pend
;---------------------------------------
;Basic MKDIR
;---------------------------------------
		#assert_cfg_16
basmkdir	.proc
		ldx #<mdtxt
                ldy #>mdtxt
                gne bascd.in
mdtxt           .null "md"
		.pend
;---------------------------------------
;Basic DIR
;---------------------------------------
		#assert_cfg_16
basdir  	.proc
		jsr dir_common
                #lda0
		jsr bas_openthis
                #jmps baserrorchannel.dir
                .pend
;---------------------------------------
;Basic LL
;---------------------------------------

basll		.proc
		.assert 0,0,0
buff		=$100
tmp		=$ae

		#assert_cfg_16

                jsr dir_common
                lda #14
		jsr bas_openthis

                tsx
                cpx #40
                bcc outm

                jsr newchrin_t
                ldx Status
                beq ok
                jsr bas_close
                lda #14
                jsr bas_openthis        ;reopen, to work around 29, disk.. on 1541
                jsr bas_xchrin
ok              cmp #"i"
                beq kd
                cmp #"a"
                beq r1541
                cmp #"d"
                beq xx
                cmp #"h"
                bne ideend
xx              geq r1581

ideloop         pla
		beq kd
ideend          #jmps bas_close

kd		jsr check_stop		;Stop?
		beq ideend

		ldx #$e0
leq             jsr newchrin_t
                sta @wbuff-$e0,x
                inx
                bne leq

                lda Status
                pha

                lda buff+$18
                and #FATTR_CLOSED | FTYPE_MASK
                beq ideloop
                and #FTYPE_MASK
                cmp #FTYPE_RELATIVE
                bne ks
                lda buff+$13
                pha
                stx buff+$13
                lda #FTYPE_RELATIVE
ks              pha
                tax

                jsr basll.print_cr

                lda ft,x
                jsr newchrout_t

                ldx #4
                lda buff+$18
                pha
lu              asl
                pha
                lda fa,x
                ldy #"-"
                jsr newchrout_tcay
                pla
                dex
                bpl lu

                lda buff+$14
                asl
                lda #"h"
;                ldy #"-"
                jsr newchrout_tcay
		jsr basll.print_space

                pla
                and #FATTR_CLOSED | FTYPE_MASK
                cmp #FTYPE_DIR
		bne np
                ldy #11
                jsr pad2
                gmi np2

np		jsr printsize

                jsr basll.print_space

np2             lda buff+$1e
                and #%00111111
                sec
                sbc #20
		bcs +
                adc #100
+               jsr printdate

                #ldatax buff+$1c
                pha
                asl
                asl
                lda buff+$1d
                pha
                ror
                cpx #$80
                ror
                lsr
                lsr
                lsr
                lsr
                jsr numy
                lda buff+$1f
                pha
                and #%00011111
                jsr numy32
                #ldatax buff+$1e
                asl
                asl
                pla
                ror
                cpx #$80
                ror
                lsr
                lsr
                lsr
                ldy #":"
                jsr numy
                pla
                and #%00111111
                jsr numy
                pla
                and #%00111111
                jsr numy32
		jsr newchrout_t

		jsr basll.print_qm

                clc
                ldy #16
                ldx #0
                jsr printname
                iny
                jsr pad
                ldy #3
                ldx #$19
                jsr printname
                jsr pad2

                bit buff+$14
                bvc chs
                ldx #0
                ldy #3
luo             lda buff+$14,y
                sta buff+$10,x
                inx
                dey
                bpl luo
                and #15
                sta buff+$13
                jsr printsize
                #jmps rel

chs		jsr basll.print_space
		lda buff+$15
		ldx buff+$16
                jsr printaxnum
		lda buff+$14
                and #$0f
                jsr printanumper
		lda buff+$17
                jsr printanumper

rel             pla
                cmp #FTYPE_RELATIVE
                bne +
                #plx_a
                jsr printxnumsp
+               #jmps ideloop
;------------
r1581		jsr bas_xchrin
		lda #229
                gne nd

r1541		ldx #141
nu		jsr bas_xchrin
                dex
                bne nu

                lda #89
nd              sta tmp

                jsr basll.print_qm

                ldx #23
nu2		jsr bas_xchrin
                cpx #7
                bne +
                lda #'"'
+               cmp #$a0
                beq sp
                cpx #6
                bne +
sp              lda #32
+		jsr newchrout_t
                dex
                bne nu2

                ldx tmp
nu3     	jsr bas_xchrin
                dex
                bne nu3

jj              lda #8
                sta tmp
                gne jju

cbmloop         pla
		beq fk
cbmend          #jmps bas_close

fk		jsr check_stop
		beq cbmend
		dec tmp
		beq jj
                jsr bas_xchrin
                jsr bas_xchrin
jju		ldx #$e2
nu4q	   	jsr newchrin_t
		sta @wbuff-$e2,x
                inx
                bne nu4q

                lda Status
                pha

		lda buff
                and #%10001111
                beq cbmloop
                and #%00001111
                pha
                cmp #8
                bcc +
                lda #7
+               pha
                tax
                jsr basll.print_cr
                lda type,x
                jsr newchrout_t

                lda buff
                asl
                pha
                lda #"-"
                ldy #"*"
                jsr newchrout_tcay

		pla
                asl
                lda #"-"
                ldy #"w"
                jsr newchrout_tcay

                ldy #5
                jsr pad2

                jsr printsize16

                jsr basll.print_space

                lda buff+$17
                jsr printdate
                lda buff+$18
                jsr numy
                lda buff+$19
                jsr numy32
                lda buff+$1a
                ldy #":"
                jsr numy
                lda buff+$1b
                jsr numy32

		ldy #4
                jsr pad2

                jsr basll.print_qm

		ldy #16
		ldx #3
neu		lda buff,x
		cmp #$a0
                beq jku
                jsr newchrout_t
                inx
                dey
                bne neu
jku             iny
		jsr pad

                #plx_a
ceq             lda type,x
                jsr newchrout_t
                #sbxc_a 256-8
                cpx #24
                bcc ceq
                jsr basll.print_space

                lda buff+$02
                pha
                ldx buff+$01
                jsr printxnum
                pla
                jsr printanumper
                pla
                cmp #4
                bne +
                ldx buff+$15
                jsr printxnumsp
                ldx buff+$13
                jsr printxnumsp
                lda buff+$14
                jsr printanumper
+               #jmps cbmloop

                #assert_8000romonly

type            .text "dspurcd?"
                .text "eersebi?"
                .text "lqgrlmr?"

                .assert CFG_8000_ROM | CFG_A000_ROM | CFG_D000_IO,CFG_8000_ROM | CFG_A000_ROM | CFG_D000_IO, CFG_8000_RAM | CFG_A000_RAM | CFG_A000_BASIC | CFG_D000_ROM

printdate       pha
                cmp #80
                lda #"1"
                ldy #"9"
                bcs vt
                #adc1
                ldy #"0"
vt              jsr newchrout_tay
                pla
		ldy #"-"
		.byte SKIP2
;------------
numy32		ldy #32
numy		sec
		ldx #47
o               inx
                sbc #10
                bcs o
                adc #58
                pha
                txa
                jsr newchrout_t
                pla
newchrout_tay   jsr newchrout_t
newchrout_tcay  bcs +
		tya
+               .byte SKIP2
print_cr        lda #13
		.byte SKIP2
print_qm        lda #'"'
                jmp newchrout_t
;------------
printname
ne		lda buff,x
                beq jk
                jsr newchrout_t
                inx
                dey
                bne ne
jk              rts
;------------
pad		lda #'"'
xi		jsr newchrout_t
;------------
pad2            lda #32
                dey
                bpl xi
		rts
;------------
m_ascii		= $69

printsize16     php
		jsr zerod
		ldy #15
p2		lda #6
		cpy #8
                rol
                jsr addd
		bpl p2
		gmi in
;------------
zerod           ldx #4
		.if SUPERCPU=1
jr              stz m_ascii,x
		.else
                lda #0
jr              sta m_ascii,x
		.fi
                dex
                bpl jr
		sei
		sed
                rts

addd		tax
		asl buff+$10,x
		ldx #4
pk      	lda m_ascii,x
		adc m_ascii,x
		sta m_ascii,x
		dex
		bpl pk
                dey
		rts
;------------
printsize       php
		jsr zerod
		ldy #31
p2k     	tya
		lsr
                lsr
                lsr
		jsr addd
		bpl p2k
in		plp
		ldx #137

uru		iny
		lda m_ascii,y
		jsr he
                cpy #4
                bcc uru
                rts
;------------
he		pha
		lsr
		lsr
		lsr
		lsr
		jsr aa
		pla
aa		and #15
		bne r2
		dex
		bmi print_space
r2		ora #$30
		tax
                .byte SKIP2
print_space     lda #32
                jmp newchrout_t
;------------
		#assert_8000romonly
ft		.text ".-rdl"
fa		.text "xwrdc"
                .pend
;---------------------------------------
;Jump far, exit in cfg16!
;
		#assert_8000romioonly
far_b79e	.proc
                ldx #<($b79e-1)
far_b7		.proc
                ldy #>($b79e-1)
far		.proc
                #psr switch_16k
                #phy_a
                #phx_a
                jmp exit2basic
		.pend
;---------------------------------------
;Basic CHANGE
;---------------------------------------
                #assert_8000romonly
s8              .null "s-8"
sd              .null "s-d"

		#assert_cfg_16
baschange      	.proc
		jsr bas_optional_devnum

		ldx #<s8
		ldy #>s8
                lda ActualDev
                cmp #8
                bne +
		ldx #<sd
                .if (>s8)!=(>sd)
                ldy #>sd
                .fi
+               jsr bas_open15commandc
                jsr bas_checkerrorclose
                lda #8
                sta ActualDev
		rts
;------------
		.assert CFG_RAM | CFG_8000_ROM | CFG_A000_ROM | CFG_D000_IO | CFG_E000_ROM, CFG_RAM | CFG_8000_ROM | CFG_A000_ROM | CFG_D000_IO | CFG_E000_ROM, CFG_OPEN_RAM |  CFG_8000_RAM | CFG_A000_RAM | CFG_A000_BASIC | CFG_D000_ROM | CFG_E000_OPEN
bas_optional_name_and_devnum .proc
		jsr newchrgot
                bne bas_required_name_and_devnum.in
                #lda0
                sta ActualFNLength
                geq bas_devcheck
;------------
		.assert CFG_RAM | CFG_8000_ROM | CFG_A000_ROM | CFG_D000_IO | CFG_E000_ROM, CFG_RAM | CFG_8000_ROM | CFG_A000_ROM | CFG_D000_IO | CFG_E000_ROM, CFG_OPEN_RAM |  CFG_8000_RAM | CFG_A000_RAM | CFG_A000_BASIC | CFG_D000_ROM | CFG_E000_OPEN
bas_required_name_and_devnum .proc
		jsr newchrgot
                beq bas_missingname
in              ldx #<($e257-1)
                ldy #>($e257-1)
                jsr far			;cfg_16 after
                #assert_cfg_16
                jsr newchrgot
                beq bas_devcheck
                ldx #<($e200-1)
                ldy #>($e200-1)
                gne bas_optional_devnum.in
;------------
		.assert CFG_RAM | CFG_8000_ROM | CFG_A000_ROM | CFG_D000_IO | CFG_E000_ROM, CFG_RAM | CFG_8000_ROM | CFG_A000_ROM | CFG_D000_IO | CFG_E000_ROM, CFG_OPEN_RAM |  CFG_8000_RAM | CFG_A000_RAM | CFG_A000_BASIC | CFG_D000_ROM | CFG_E000_OPEN
bas_optional_devnum .proc
                ldx #<($b79e-1)
                ldy #>($b79e-1)
in		jsr newchrgot
                beq skip
                jsr far			;cfg_16 after
                #assert_cfg_16
                stx ActualDev
skip
;------------
		#assert_8000romioonly
bas_devcheck	.proc
		lda ActualDev
		cmp #4
                bcc bas_illegaldev
in              cmp #31
                bcs bas_illegaldev
                rts
;------------
		#assert_8000romioonly
bas_missingname	.proc
		lda #KERNAL_MISSING_FILENAME
                .byte SKIP2
bas_outofmemory	.proc
		lda #KERNAL_OUT_OF_MEMORY
                .byte SKIP2
bas_illegaldev  .proc
		lda #KERNAL_ILLEGAL_DEVICE_NUMBER
bas_ioerror     .proc
		.if SUPERCPU=0
                tax
                .fi
                .if (((JIFFYDOS_ACCEL=1) & (SUPERCPU=0)) | (DOLPHINDOS_ACCEL=1)) & (JIFFYDOS_ACCEL_CHRINOUT=0)
                #sta_cfg_open
                .if SUPERCPU=1
                tax
                .fi
                #lda0
                sta dos_accel_internal_exp
                .if SUPERCPU=1
                txa
                .fi
                .fi
                #psr $e0f9
                .if SUPERCPU=0
                txa
                .fi
                jmp exit2basic
                .pend
;------------
		#assert_8000romioonly
bas_open15commandc jsr bas_commandc
bas_open15	lda #15
bas_openthis	sta ActualSecAddr
bas_open      	.proc
		jsr bas_open_common
                jsr chkinx
                bcs bas_ioerror
                rts

chkinx          #psr switch_16k
		jmp __chkin		;newchkin_t
                .pend

		#assert_8000romioonly
bas_open_common .proc
		jsr LWOP_findunusedchannel;cfg_open after
		#assert_cfg_open
                .if (((JIFFYDOS_ACCEL=1) & (SUPERCPU=0)) | (DOLPHINDOS_ACCEL=1)) & (JIFFYDOS_ACCEL_CHRINOUT=0)
                lda #1
                sta dos_accel_internal_exp
                .fi
		jsr newopen_t
                #assert_cfg_16
                bcs bas_ioerror
		ldx ActualLogical
                rts
                .pend
;------------
		.assert CFG_8000_ROM | CFG_A000_ROM | CFG_D000_IO,CFG_8000_ROM | CFG_A000_ROM | CFG_D000_IO, CFG_8000_RAM | CFG_A000_RAM | CFG_A000_BASIC | CFG_D000_ROM
bas_close	.proc
		lda ActualLogical	;Close file
		jsr newclose_t
                #assert_cfg_16
                bcs bas_ioerror
		jsr newclrchn_t
		.if (((JIFFYDOS_ACCEL=1) & (SUPERCPU=0)) | (DOLPHINDOS_ACCEL=1)) & (JIFFYDOS_ACCEL_CHRINOUT=0)
                #sta_cfg_open
                #lda0
                sta dos_accel_internal_exp
                .fi
                rts
                .pend
;------------
		.assert CFG_8000_ROM | CFG_A000_ROM | CFG_D000_IO,CFG_8000_ROM | CFG_A000_ROM | CFG_D000_IO, CFG_8000_RAM | CFG_A000_RAM | CFG_A000_BASIC | CFG_D000_ROM
bas_xchrin     	.proc
		jsr newchrin_t
                #assert_cfg_16
		ldy Status
		beq oekj
		pla
		pla
		#jmps bas_close
oekj		rts
		.pend

		.assert CFG_8000_ROM | CFG_A000_ROM | CFG_D000_IO,CFG_8000_ROM | CFG_A000_ROM | CFG_D000_IO, CFG_8000_RAM | CFG_A000_RAM | CFG_A000_BASIC | CFG_D000_ROM
bas_checkerrorclose .proc
		jsr newchrin_t
                #assert_cfg_16
                eor #"0"
                cmp #1
                eor #"0"
                php
cuc             plp
		php
                bcc nomess
		bit msgmode
		bpl nomess
		jsr newchrout_t
nomess		lda Status
                bne xnx
                jsr newchrin_t
                bcc cuc
xnx             jsr bas_close
		plp
		rts
                .pend
