;
; channel15.asm - channel 15 command execution
;
; Written by
;  Kajtar Zsolt <soci@c64.rulez.org>
;
;    This file is part of IDEDOS the IDE64 disk operating system
;    See README for copyright notice.
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
		#assert_cfg_open

OP_XIT_do_command_channel .proc

		#xit_init

                jsr OP_buffer_start_pom1_y

                .if SUPERCPU=0
                tya
                .fi
		#ldy_l_a buffer_address_low_exp,x
                beq OP_XIT_execute_15command_open.rrts
                .if SUPERCPU=1
                #lda0
                .fi
                sta buffer_address_low_exp,x
		cpy #254
		jsr LWOP_reporterror_32_xit;-=> buffer overflow

		#lda_zp_y pom1
		eor #13			;remove trailing CR
		beq +
		iny
+
                .if SUPERCPU=1
                phx
                .fi
		#lda0			;trailing zero
		.byte SKIP2

thnue		#lda_zp_y pom1		;copy from buffer to path
		dey
		#sta_l_y_x path_exp
		bne thnue
                .if SUPERCPU=1
                plx
                .fi

OP_XIT_execute_15command_open .proc

		lda buffer_drive_exp,x
		sta current_drive_exp

		#xit_init

;		jsr check_drive		;check drive is alive
		jsr LWOP_reporterror_ok

		lda path_exp
		ldx #commandslo-commands
htnuo		cmp commands-1,x
		beq jooocmd
		dex
		bne htnuo
		geq channel15_cont

jooocmd		.if SUPERCPU=1
		txa
                asl
                tax
                .else
		lda commandshi-1,x
		pha
		lda commandslo-1,x
		pha
                .fi
		lda path_exp+1
		cmp #"-"
                .if SUPERCPU=1
                jmp (commandslo-2,x)
                .fi
rrts    	rts
;-------------------------------
;C
;
cmd_c		.proc
		cmp #"P"
		bne cmd_cp
		lda path_exp+2          ;cP
in		pha
		jsr XIT_init_drive
                pla
		jsr OP_check_partition_selection;Invalid? -=> error
                jsr LWOP_reporterror_77_xit
		#ldx_l_a current_drive_exp
                tya
		sta drive_workpartition_exp,x
		#adc1
		tax
		ldy #0
                lda #2			;02, PARTITION SELECTED
                sec
		gcs LWOP_reportxy
		.pend
;-------------------------------
;CP change partition
;
; Syntax:
;
;"CP" report working partition
;"CP2" select working partition
;
cmd_cp		.proc
		cmp #"p"
		bne cmd_cd

		jsr OP_get_partnum	;CP
		lda current_path
                gpl cmd_c.in
		.pend
;-------------------------------
;CD change dir
;
;CD:/	- go to root
;CD:<-	- go to parent
;CD:DIR	- go into dir
;
cmd_cd		.proc
		cmp #"d"		;CD hack ;)
		bne ide64

re              jsr OP_get_partnum	;CD
		sta path_partition_exp
		bcc jo
                lda path_exp+2
                eor #"/"		;"CD/.......
                bne df
                tax
lp              inx
                lda path_exp+2,x
                sta path_exp-1,x
                bne lp
                geq in

df		eor #95^"/"
		ora path_exp+3
                beq pphack		;"CD<-"
                gne ill

jo		lda path_exp+1		;"CD:<-"
		eor #95
                ora path_exp+2
		bne in

pphack  	sta path_exp+2
		lda #"."
		sta path_exp
		sta path_exp+1
		gne in

ide64		jsr OP_get_partnum
		sta path_partition_exp
ill     	bcs LWOP_reporterror_30_xit;-=> error

in		jsr XIT_init_drive	;-=> error
		clc			;there was a colon
                clv			;resolv from working dir
		lda #RESOLV_CD_MODE
		jsr OP_XIT_resolv_path	;-=> path    CD:
                jsr LWOP_reporterror_39_xit;-=> error

		#ldx_l_a partition_currentp_exp	;ok

		ldy #0
bnmf		lda next_sector,y
		sta partition_workdir_exp,x
		inx
		iny
		cpy #4
		bne bnmf
		rts			;-=> OK, exit
		.pend
;-------------------------------
;S remove file
;
cmd_s		.proc
scratch_file_num = $a4

                bne nj
                lda #"s"
                gne channel15_cont
nj
                #stz_a scratch_file_num
                #stz_aa scratch_file_num+1
                jsr XIT_init_drive
                jsr OP_get_partnum
                pha
                jsr LWOP_reporterror_30_xit
                pla
retry2          clv			;resolv from working dir
                sta path_partition_exp
retry     	lda #RESOLV_S_MODE
                php
		jsr OP_XIT_resolv_path	;-=> path  S:
                lda path_exp
                bcs notf		;file not found

                jsr rewrite_file

                plp
		clc
		inc scratch_file_num
                bne retry_same
                inc scratch_file_num+1
                gcc retry_same

kik		jsr OP_short_path
notf		beq ende
		cmp #":"
		beq veg
set_v		cmp #","
                bne kik
                jsr OP_short_path
                jsr OP_get_partnum
		rol
		plp
                lsr
                bcc retry2
retry_same    	ldx #3
-               bvs +
		lda resolv_this_dir_exp,x
                sta scratch_this_dir_exp,x
+		lda scratch_this_dir_exp,x
                bcs +
                lda resolv_this_sector_exp,x
+               sta resolv_this_dir_exp,x
                dex			;continue from this sector next time
                bpl -
                sec
		#sev set_v		;resolv from last dir
                gvs retry

veg		gcs LWOP_reporterror_33_xit

ende            ldx scratch_file_num
		ldy scratch_file_num+1
                sec
		gcs LWOP_reporterror_01_xit

rewrite_file    .proc			;entry point for "@:"
		jsr XIT_wp

		jsr XIT_is_locked

		lda direntry_f_attrib_exp
                asl
		and #(FATTR_DELETE | FTYPE_MASK) << 1
		eor #(FATTR_DELETE | FTYPE_LNK) << 1
                php
                beq ok
		eor #(FTYPE_LNK ^ FTYPE_RELATIVE) << 1
                beq ok
		eor #(FTYPE_RELATIVE ^ FTYPE_NORMAL) << 1
                sec
                bne LWOP_reporterror_26_xit; other types not done yet
ok
                lda #3
                tay
                jsr copyto

		jsr XIT_kill_entry	;remove directory entry

		plp
		bcc nono		;not closed file, so no freeing
                php

		jsr eraseprepare

                ldx #3
                plp
                bne nlnk
                jsr copyback
                jsr XIT_free_this_sector
ende            #jmps XIT_find_free_flush

nlnk            #stx_l_a scratch_sp_exp

rec_free
		#ldx_l_a scratch_sp_exp
		cpx #255
		beq ende

                jsr copyback
		#stx_l_a scratch_sp_exp

		lda #ram_exp_tree
		jsr XIT_read_a_sector

		lda #255
                pha
		gne in			;free tree sector too

nono		rts			;-=> exit

slp             pha
		asl
		asl
		sta pom1
		lda #ram_exp_tree/2
		rol
		sta pom2
		.if SUPERCPU=1
		lda #1
		sta pom3
		.fi

		ldy #3
-		#lda_zp_y pom1
		sta next_sector,y
		dey
		bpl -
                jsr next_sector0
		beq +

in		jsr XIT_free_this_sector

+               pla
                #adc1c
		bpl slp

		.if SUPERCPU=1
		ldy #1
		sty current_path+2
                dey
		.else
		ldy #0
                .fi
		sty current_path
		lda #ram_exp_tree
		sta current_path+1

		lda #8
		sta pom1

ns		ldx #3
-		#lda_zp_y current_path
		asl
		asl
		asl
		rol next_sector,x
		asl
		rol next_sector,x
		tya
		clc
		adc #4
		tay
		and #15
		bne -
		dex
		bpl -
		bcc +
		inc current_path+1
+
		jsr next_sector0
		beq +

                #phy_a
                ldy #3
                tya
                sec
		adc scratch_sp_exp
		sta scratch_sp_exp
		jsr copyto
		#ply_a

+		dec pom1
		bne ns
		geq rec_free

copyto          tax
-		lda next_sector,y
		sta ram_exp_buffer0_exp,x
		dex
		dey
		bpl -
                rts

copyback	ldy #3
-		lda ram_exp_buffer0_exp,x
		sta next_sector,y
		dex
		dey
		bpl -
                rts
		.pend

XIT_kill_entry	.proc
		jsr XIT_posentry

		ldy #$18		;filetype exp
		#lda_zp_y pom1
		and #<~(FTYPE_MASK | FATTR_CLOSED)
in		#sta_zp_y pom1

XIT_writeoutdir	.proc
		lda #ram_exp_dir
		gne XIT_write_a_sector	;first kill entry, than free space
                .pend

cmdnotimp	.proc
		sec
		gcs LWOP_reporterror_31_xit;Unknown command
		.pend
;-------------------------------
;P position
;
cmd_p		.proc
tmpreclen       = next_sector

		jsr search_channel_A
		bne seekappend.err2

		lda buffer_type_exp,x       ;-=> seeking only for CFS and ISO!
                cmp #BUFFERMODE_RELATIVE
                bne nrel
                #phx_a
                lda buffer_recordlen_exp,x
                sta tmpreclen
                lda path_exp+4
                beq +
                #sbc1
+               cmp tmpreclen		;recordlen?
                bcc +
                lda #$80+51             ;overflow in record hack
                jsr seekappend.set_error
        	#lda0
+       	sta buffer_recordpos_exp,x
                pha
                lda buffer_recordpad_exp,x
                pha
                beq nopadcalc

                jsr seekappend.rnumtoszam
                #stz_aa szam+3
                lda buffer_recorddiv_exp,x
                tax
                jsr div
                .if SUPERCPU=1
                plx
                phx
                .else
                pla
                tax
                pha
                .fi
                jsr mul
                sta szam+3
                ldy #$ff
                .byte SKIP2

nopadcalc       ldy #0
		lda tmpreclen
                pha
k               ldx #3
-               tya
                and szam,x
		sta next_sector,x
                dex
                bpl -
	       	jsr seekappend.rnumtoszam
                #plx_a
                stx szam+3
                jsr mul
                pla
                jsr sum
                pla
                jsr sum
                ldx #0
                ldy #4
                clc
-               lda szam,x
                adc next_sector,x
                sta path_exp+2,x
                inx
                dey
                bne -
                #plx_a
		lda #BUFFERMODE_SEEKABLE
nrel		and #BUFFERMODE_SEEKABLE
                beq seekappend.err2

		lda buffer_info_exp,x
seekappend     	.proc
		ldy #stateless-statenow
ver		cmp statenow-1,y
		beq vy
		dey
		bne ver

err2		sec
		gcs LWOP_reporterror_70_xit

vy		lda #INFO_IGNORE	;be safe
		sta buffer_info_exp,x
                lda buffer_partition_exp,x
                sta partition_currentp_exp

		#phy_a

		lda statewhat-1,y
                sta path_exp		;state
		bpl +		;buffer is not dirty

		jsr XIT_flush_buf

+
                ldx #3
                ldy #0
-               lda path_exp+2,x
                sta next_sector,y
                iny
                dex
                bpl -
                #ldx_l_a buffer_currentp_exp

		lda next_sector+2
                eor buffer_filepos2_exp,x
                sta szam
		lda next_sector+1
                eor buffer_filepos3_exp,x
                bne +
		lda next_sector
                eor buffer_filepos4_exp,x
+               sta szam+1

		lda next_sector+3
		cmp buffer_filesize1_exp,x
		lda next_sector+2
		sbc buffer_filesize2_exp,x
		lda next_sector+1
                sta buffer_filepos3_exp,x
		sbc buffer_filesize3_exp,x
		lda next_sector
                sta buffer_filepos4_exp,x
		sbc buffer_filesize4_exp,x

		#ply_a

		lda stateless-1,y
		bcc less
		lda stateend-1,y	;reached eof
                pha
                lda #$80+50             ;record not present hack
                jsr set_error
                pla
less		pha

		lda buffer_address_max_hi_exp,x
                clc
                sbc buffer_start,x
                pha
                and next_sector+2
                sta path_exp+3
		ora next_sector+3
                tay
                pla
                eor #$ff
                pha
                and szam
                ora szam+1
                bne +
                lda buffer_address_end_hi_exp,x
                beq +
                clc
+               pla
                and next_sector+2
		sta buffer_filepos2_exp,x

                tya
		beq fer			;buffer start?

                bcc dddd                ;sector already in buffer

		lda buffer_type_exp,x
		cmp #BUFFERMODE_ISOFILE
		bne cfs

		ldy #3
-               lsr next_sector
                ror next_sector+1
                ror next_sector+2
                dey
                bne -
                sty next_sector-1

                txa
                asl
                asl
                tax
                ldy #3
-               lda next_sector-1,y
                adc buffer_isofile_start_exp,x
                sta next_sector,y
                inx
                dey
                bpl -
                .cerror (next_sector-1)!=(current_path+2)

                jsr OP_buffer_start
                jsr XIT_read_a_sector
                #jmps dddd

cfs		jsr XIT_init_drive	;-=> error
		lda path_exp		;state?
		beq rrd
		jsr XIT_save_tree	;-=> error
		#jmps tr

rrd		jsr XIT_load_tree	;-=> error

tr		sec			;force clear
		jsr XIT_read_in_buffer	;-=> error

dddd		#ldx_l_a buffer_currentp_exp

		lda buffer_filesize1_exp,x
		sec
		sbc #1
		tay
		lda buffer_filesize2_exp,x
		sbc buffer_filepos2_exp,x
		sta pom2
		lda buffer_filesize3_exp,x
		sbc buffer_filepos3_exp,x
		bne more
		lda buffer_filesize4_exp,x
		sbc buffer_filepos4_exp,x
		bcc more
		bne more

		lda buffer_address_max_hi_exp,x
;		sec
		sbc buffer_start,x
		clc
		sbc pom2
		bcc more

		lda pom2
		ora buffer_start,x
                gcs fer

more		ldy #0
		lda buffer_address_max_hi_exp,x
fer     	sta buffer_address_end_hi_exp,x
		tya
		sta buffer_address_end_low_exp,x

		lda path_exp+2
		sec
		sbc #1
		sta buffer_address_low_exp,x
		lda path_exp+3
		sbc #0
		clc
		adc buffer_start,x
		cmp buffer_address_end_hi_exp,x
		bne krk
                pha
                lda buffer_address_low_exp,x
                cmp buffer_address_end_low_exp,x
                pla
                bcs krk
		ora #$80
krk		sta buffer_address_hi_exp,x

		pla
		sta buffer_info_exp,x
		rts				;-=> exit, OK

rnumtoszam      lda path_exp+2
                sec
                sbc #1
                sta szam
                lda path_exp+3
                sbc #0
                bcs +
                #lda0
                sta szam
+               sta szam+1
                #stz_a szam+2
                rts

set_error       .if SUPERCPU=1
                xba
                txy
                lda buffer_drive_exp,x
                tax
                xba
                sta status_pos_exp,x
                tyx
                .else
		ldy buffer_drive_exp,x
                sta status_pos_exp,y
                .fi
                .if DRIVES=4
                bit errledon_g
                .fi
                rts

statenow	.byte INFO_BLK_READ ,INFO_BLK_R_EOF,INFO_BLK_WRITE,INFO_BLK_WRITE_DIRTY,INFO_BLK_RW    ,INFO_BLK_RW_EOF,INFO_BLK_RW_DIRTY,INFO_BLK_RW_EOF_DIRTY,INFO_RELATIVE,INFO_RELATIVE_WRITE_DIRTY,INFO_RELATIVE_READ,INFO_RELATIVE_READ_DIRTY,INFO_RELATIVE_DIRTY,INFO_RELATIVE_WRITE_DIRTY_FULL
stateless	.byte INFO_BLK_READ ,INFO_BLK_READ ,INFO_BLK_WRITE,INFO_BLK_WRITE      ,INFO_BLK_RW    ,INFO_BLK_RW    ,INFO_BLK_RW      ,INFO_BLK_RW	       ,INFO_RELATIVE,INFO_RELATIVE            ,INFO_RELATIVE     ,INFO_RELATIVE           ,INFO_RELATIVE      ,INFO_RELATIVE
stateend	.byte INFO_BLK_R_EOF,INFO_BLK_R_EOF,INFO_BLK_WRITE,INFO_BLK_WRITE      ,INFO_BLK_RW_EOF,INFO_BLK_RW_EOF,INFO_BLK_RW_EOF  ,INFO_BLK_RW_EOF      ,INFO_RELATIVE,INFO_RELATIVE            ,INFO_RELATIVE     ,INFO_RELATIVE           ,INFO_RELATIVE      ,INFO_RELATIVE
statewhat	.byte 0             ,0             ,1             ,128                 ,1              ,1              ,128              ,128		       ,1            ,128                      ,1                 ,128                     ,128                ,128
		.pend
;-------------------------------
;M make dir
;
;"MD:NEW"
;
cmd_m		.proc
                bne nj
                lda #"m"
                gne channel15_cont

nj              lda #RESOLV_MD_MODE
		jsr OP_XIT_resolv_path_part_init;-=> error  MD:
		bcs jo
		sec
		gcs LWOP_reporterror_63_xit;-=> file exists
jo
		#lda0
		sta path_searchtype_exp
		lda #ram_exp_bitmap
                ldx #"/"
                clc
                clv
		jsr XIT_prealloc_dir_sector;-=> error

		lda #FIND_FREE_METADATA
		jsr find_free_space	;allocate dir sector

                lda #ram_exp_buffer0
                jsr clear512
                ldx #$f0
                clc
-               bcs j
		lda path_exp-$f0,x	;fill in filename
		bne j
                sec
		lda #32
j		sta ram_exp_buffer0_exp-$f0,x
		inx
		bne -

		ldx #3
ns		lda cdir,x
		sta ram_exp_buffer0_exp+$18,x;type & attrib
		lda next_sector,x
		sta ram_exp_buffer0_exp+$10,x;pointer
                sta created_new_dir_sector_exp,x;for finalize_direntry
		lda resolv_this_dir_exp,x
		sta ram_exp_buffer0_exp+$14,x;parent
		dex
		bpl ns
                and #%01001111
                sta ram_exp_buffer0_exp+$14;pointer
                lda next_sector
                and #%01001111
		sta ram_exp_buffer0_exp+$10;pointer

                lda #ram_exp_buffer0
                sta pom2
                jsr OP_timestamp	;update timestamp

		lda #ram_exp_buffer0	;write out new dir sector
		jsr XIT_write_a_sector	;-=> error

		jsr XIT_find_free_flush	;-=> error

		ldx #2
sw		lda cdir+1,x
		sta path_searchtype_exp,x
		#stz_a szam,x
		dex
		bpl sw
		#stz_aa szam+3

		lda #FTYPE_DIR | FATTR_EXEC | FATTR_READ | FATTR_WRITE | FATTR_DELETE | FATTR_CLOSED
                sec
		gcs XIT_finalize_direntry	;-=> exit, OK

cdir		.byte FTYPE_DIR | FATTR_EXEC | FATTR_READ | FATTR_WRITE | FATTR_DELETE,"dir"
		.pend
;-------------------------------
;"R-H:NEW" rename header
;"R-P:NEW=OLD" rename partition
;
cmd_r		.proc
                bne jfj
                lda path_exp+2
                cmp #"h"
                bne rename

		lda #RESOLV_RH_MODE
		jsr OP_XIT_resolv_path_part_init;-=> error  R-H:

                lda #ram_exp_dir
		jsr XIT_read_a_sector	;read in dir sector

		lda ram_exp_dir_exp+$18
                sta resolv_dirattrib_exp
		and #FTYPE_MASK | FATTR_CLOSED
		eor #FTYPE_DIR
                tax
                cmp #1
		jsr LWOP_reporterror_71_xit;-=> directory error

                jsr XIT_wp

		ldx #$f0
                clv
jf              bvs s
		lda path_exp-$f0,x
                beq n
set_v           cmp #","
                bne s
n               #sev set_v
                lda #32
s               sta ram_exp_dir_exp-$f0,x
                inx
                bne jf
		geq XIT_writeoutdir     ;-=> exit, OK  write out dir sector

jfj             cmp #"d"
                beq cmd_rd
;-------------------------------
; R rename or move
;
;"R/DEST/:NEW=/SOURCE/:OLD"
;
rename		.proc
		jsr XIT_init_drive
                jsr OP_get_partnum
                sta path_partition_exp
                pha
missing         jsr LWOP_reporterror_30_xit

		sec
		ldx #255
jj              inx
		lda path_exp,x
                beq missing
                sta ram_exp_dir_exp,x
                eor #"="
                bne jj
                sta ram_exp_dir_exp,x
                ldy #255
clp             inx
                iny
                lda path_exp,x
                #sta_l_y path_exp
                bne clp

		jsr OP_get_partnum
                bcs krk			;not given, use the previous
                sta path_partition_exp
krk             clv			;Resolv from working dir
                lda #RESOLV_R2_MODE
                jsr OP_XIT_resolv_path	;-=> error  R:

		jsr XIT_wp		;source writable?

                jsr XIT_is_locked	;locked?

                pla
                sta path_partition_exp

                jsr XIT_posentry	;dir sector needed
                lda pom2
                eor #ram_exp_dir^ram_exp_tree
                sta pom2

                clc
                ldx #255
jj2		inx
                lda ram_exp_dir_exp,x
                sta path_exp,x
                beq cc
                eor #","
                bne jj2
                sec
                gcs jj2
cc
		bcs volt

                ldy #$18
                lda #","
                .byte SKIP2
idk             #lda_zp_y pom1		;append original type
                sta path_exp,x
                inx
                iny
                cpy #$1c
                bcc idk
                #lda0
                sta path_exp,x
volt
		#psz pom1

                lda partition_currentp_exp
                pha
                ldy #$17
	        ldx #3
p2              lda resolv_this_dir_exp,x
		pha
                #lda_zp_y pom1
		sta rename_old_dir_exp,x
                lda next_sector,x
                sta rename_old_dirsect_exp,x
                dey
                dex
                bpl p2

		lda #RESOLV_R_MODE
                clc			;after colon
                clv			;from working dir
		jsr OP_XIT_resolv_path	;-=> error  R:
		bcs jo
		sec
		gcs LWOP_reporterror_63_xit;-=> file exists

invl		.text "delreldirlnk"

jo
		ldy #255
is              iny
		#lda_zp_y current_path
                beq jr
                eor #","
                bne is
                #sta_zp_y current_path
jr
                ldx #$fc
                clc
p2e             pla
		eor resolv_this_dir_exp-$fc,x
                beq +
                sec
+               inx
                bne p2e
                #sev set_v                  ;check filename only
                pla
                bcc same_directory
                eor partition_currentp_exp
                bne LWOP_reporterror_39_xit;different partition, sorry
                clv			    ;allocate new dir sector if needed
same_directory
		php
                ldx #0
                lda setup_atribut2_exp
                bmi +
                ldx #"/"
+		lda #ram_exp_bitmap
                clc
		jsr XIT_prealloc_dir_sector

		plp
		pla
                sta current_path
                pla
                sta current_path+1
                .if SUPERCPU=1
                lda #1
                sta current_path+2
                .fi
                php

		ldx #0
		#txy_a
ii		lda path_exp,x		;fill in filename
		beq +
		inx
+		#sta_zp_y current_path
		iny
set_v	 	cpy #$10
		bcc ii

		#sev set_v
		ldx #0
		ldy #$19
scw		lda path_searchtype_exp,x
		beq +
                inx
+               #cmp_zp_y current_path
                beq +
                clv
+               #sta_zp_y current_path 	;fill in filetype
		iny
		cpy #$1c
		bcc scw
                bvs kih2		;filetype unchanged?

                ldx #11
xjj             sec
		ldy #$1b
iei             #lda_zp_y current_path
                eor invl,x
                beq +
                clc
+               dex
                dey
                tya
                eor #$18
                bne iei
                bcs invt		;invalid type
xj		txa
		bpl xjj
;                clv
kih2
		ldy #$18
                #lda_zp_y current_path
                and #FTYPE_MASK | FATTR_CLOSED
                cmp #FTYPE_DIR
                beq LWOP_reporterror_26_xit;do not rename dirlabel
                and #FTYPE_MASK
                cmp #FTYPE_NORMAL
                beq thd			;regular file?
                sec
invt            bvc LWOP_reporterror_64_xit;rename of a reserved type! (eg. dir to prg)
thd
                plp
                bcs diffdir

writeold        #cnext rename_old_dirsect_exp, next_sector
		lda #ram_exp_tree
                jmp XIT_write_a_sector	;same directory, no problem

diffdir		jsr XIT_posentry

                ldy #$14
                .check CFG_OPEN_RAM, CFG_RAM
                .if SUPERCPU=1
                lda [pom1],y
                tax
                .else
                lax (pom1),y
                .fi
                ldy #31
ksk             #lda_zp_y current_path
                #sta_zp_y pom1
                dey
                bpl ksk
                txa
                ldy #$14
                #eor_zp_y current_path
                #andclc %00110000
                #eor_zp_y current_path
                #sta_zp_y pom1		;do not destroy directory link!

                ldy #$18
                #lda_zp_y current_path
                pha
                and #<~(FATTR_CLOSED | FTYPE_MASK);remove file
                #sta_zp_y current_path
                pla
                pha
                and #<~FATTR_CLOSED
		#sta_zp_y pom1
                and #FTYPE_MASK
                eor #FTYPE_DIR
                bne sf
                sec
                #lda_zp_y current_path
                #sta_zp_y pom1	   	;remove
sf		php
		bcc ndir0

                #cnext resolv_this_dir_exp, next_sector

nrootdir        lda #ram_exp_buffer0
                jsr XIT_read_a_sector

		#sev set_v
                sec
                ldx #0
                #txy_a
ir              lda next_sector,x
                eor rename_old_dir_exp,x
                bcc do
                and #%01001111
do		beq +
		tay
+		lda ram_exp_buffer0_exp+$14,x
		sta next_sector,x
                eor ram_exp_buffer0_exp+$10,x
                bcc do2
                and #%01001111
do2		beq +
		clv
+		inx
                cpx #4
                bcc ir
                tya
                beq LWOP_reporterror_39_xit;no loops please...
                bvc nrootdir

ndir0           jsr XIT_write_new     	;write non-closed destination
                plp
                php
                bcc ndir1

		jsr dirc
                jsr XIT_read_a_sector	;read in directory's first sector
ndir1
		jsr writeold		;remove old file
                plp                     ;if we crash here then say
                bcc ndir2               ;goodbye to your data...

                ldx #3
jje             lda resolv_this_dir_exp,x
                sta ram_exp_buffer0_exp+$14,x
                dex
                bne jje
                lda ram_exp_buffer0_exp+$14
                eor resolv_this_dir_exp
                and #%10110000		;do not destroy directory link!
                eor resolv_this_dir_exp
                sta ram_exp_buffer0_exp+$14

                jsr dirc
                jsr XIT_write_a_sector  ;write out directory's first sector

ndir2           jsr XIT_posentry.in
                pla
                ldy #$18
                #sta_zp_y pom1 		;write out new entry again

XIT_write_new 	jsr resolv_empty_entry_exp_to_next_sector
                jmp XIT_writeoutdir     ;write non-closed destination

dirc            ldy #$14
iic             #lda_zp_y current_path
                sta next_sector-$14,y
                iny
                cpy #$18
                bcc iic
                lda #ram_exp_buffer0
		rts
		.pend
;-------------------------------
;RD rmdir
;
cmd_rd		.proc
		lda #RESOLV_RD_MODE
		jsr OP_XIT_resolv_path_part_init;-=> error  RD:
re              ldx #0
		bcs filenotf		;-=> file not found

		jsr XIT_wp

		lda direntry_f_attrib_exp
		and #FATTR_DELETE | FTYPE_MASK | FATTR_CLOSED
		eor #FATTR_DELETE | FTYPE_DIR | FATTR_CLOSED
		bne LWOP_reporterror_26_xit;write protected

                sec
                ldy #3
                tya
		ora partition_currentp_exp;ok
                tax
lk              lda next_sector,y
                pha
		eor partition_workdir_exp,x
                beq +
                clc
+               dex
                dey
                bpl lk
                bcs LWOP_reporterror_60_xit  ;cannot remove the working directory

;		clc
		jsr XIT_test

                jsr XIT_kill_entry	;remove directory entry

		jsr eraseprepare

		ldx #0
ll		pla
                sta next_sector,x
                inx
		cpx #4
		bcc ll

;               sec
                jsr XIT_test
		jsr XIT_find_free_flush
                ldx #1
filenotf        ldy #0
                sec
                gcs LWOP_reporterror_01_xit

XIT_test       	#lda0
		sta current_path
                .byte SKIP1BNE
lo		plp
                php
                bcc sk

		ldx #3
le              lda next_sector,x
                pha
                dex
                bpl le

                jsr XIT_free_this_sector

		ldx #0
le2             pla
                sta next_sector,x
                inx
                cpx #4
                bne le2

sk
		jsr OP_read_cmd1
                bcs broken		;disk error...

                ldy #15
nj2             ldx #11
nj              lda data_g
                dex
                bne nj
                .if FAST_DATA_TRANSFERS
                pha
                .fi
                tya
                lsr
                lsr
                tax
                .if FAST_DATA_TRANSFERS
                pla
                .else
                lda low_reg
                .fi
                asl
		asl
		asl
		rol next_sector,x
		asl
		rol next_sector,x
		bit data_g
		lda data_g
                #lda_low_reg
                and #FATTR_CLOSED | FTYPE_MASK
                beq xjx
                cmp #FTYPE_DIR
                beq xjx
                sec
                rol current_path
xjx             bit data_g
                bit data_g
                bit data_g
                dey
                bpl nj2

		jsr wait_busy
                bcc ok2

broken          plp                     ;disk error...
		tax
                lda direct_write_exp
                beq errr                ;no direct write, no remove...
                bcc problem
errr		txa
		sec
		gcs LWOP_reporterror_read_xit	;-=> error

ok2             plp
                php
                bcs sk2

                lda current_path
                sec
                bne re				;non-empty directory
sk2
		jsr next_sector0
                bne lo
                plp
problem         rts
		.pend
;-------------------------------
;L lock
;
cmd_l		.proc
		lda #RESOLV_L_MODE
		jsr OP_XIT_resolv_path_part_init;-=> error  L:

		jsr XIT_wp

                ldy #$fc
kfj             #lda_l_y_ direntry_f_pointer_exp-$fc
                eor partition_del_dir_exp,x
                bcc +
                #andclc %01001111
+               bne mas
                inx
                iny
                bne kfj
                rts			;-=> exit, OK  ignore
mas
		jsr XIT_posentry

		ldy #$18		;filetype exp
                .check CFG_OPEN_RAM, CFG_RAM
                .if SUPERCPU=1
                lda [pom1],y
                tax
                .else
                lax (pom1),y
                .fi
                and #FTYPE_MASK | FATTR_CLOSED
                cmp #FTYPE_DIR
                beq LWOP_reporterror_62_xit; dirlabel?!
		txa
                bit i			;write and delete cleard?
                beq set
                and #<~(FATTR_WRITE | FATTR_DELETE)
                .byte SKIP2
set             ora #FATTR_WRITE | FATTR_DELETE
		bit i2			;DEL file?
                bne +
                and #<~(FATTR_READ | FATTR_WRITE | FATTR_EXEC)
+		pha
                jsr XIT_kill_entry.in
                pla
                pha
                and #FTYPE_MASK
                cmp #FTYPE_DIR
                bne notdir

                #cnext direntry_f_pointer_exp , next_sector

                lda next_sector
                asl
                php

                lda #ram_exp_dir
		jsr XIT_read_a_sector	;read in dir sector

                lda ram_exp_dir_exp+$14
                asl
                plp
                ror
                sta ram_exp_dir_exp+$14	;copy hidden

                pla
                and #<~(FATTR_CLOSED)
                sta ram_exp_dir_exp+$18	;copy attr

		jmp XIT_writeoutdir     ;-=> exit, OK write out dir sector

notdir		pla
		rts			;-=> exit, OK

i               .byte FATTR_WRITE | FATTR_DELETE
i2		.byte FTYPE_MASK
                .pend
;-------------------------------
;Free the next_sector in bam
;
XIT_free_this_sector .proc
                jsr chs2lba

                jsr boundend
                bcs qu

		lda szam+0
		sec
		sbc find_free_start_exp+0
		pha
		#stz_a szam+0
		lda szam+1
		sbc find_free_start_exp+1
		pha
		and #$f0
		sta szam+1
		lda szam+2
		sbc find_free_start_exp+2
		sta szam+2
		lda szam+3
		sbc find_free_start_exp+3
		sta szam+3
                bcs ok
		pla
		pla
qu		rts			;no access beyond partition...

ok
                ldx #3
ce		lda szam,x
		cmp scratch_now_exp,x
		bne vw
		dex
		bne ce
		geq ncw

vw
		ldx #0
		lda find_free_bam_exp
		lsr
		ldy #3
li		lda szam,x
		sta scratch_now_exp,x
		adc find_free_start_exp,x
		pha
		inx
		dey
		bpl li

		jsr XIT_find_free_flush

		ldx #3
li2             pla
                sta szam,x
                sta find_free_now_exp,x
                dex
                bpl li2

                .if SMART_ALLOC
                ldx #find_free_skipm_drivepart_exp-find_free_skip_drivepart_exp
                sec
sl              jsr s_check_range
                bcc nt
                cmp find_free_skip_to_exp-4,x
                bcs nt
                sta find_free_skip_to_exp-4,x
nt              cpx #1+4
                ldx #0
                bcs sl
                .fi

                jsr isbamlocked
                lda buffer_start,x
                ora #>b_cfs_file_bitmap_exp	;modify bam directly in file's bam
		bcs +
                lda #ram_exp_bitmap		;modify bam in own buffer
+               sta find_free_buf_exp+1
                bcs noread

		jsr readinbam.in

noread          lda #1
                sta find_free_dirty_exp

ncw		pla
		and #$0f
		sta pom2
		pla
                .if SUPERCPU=1
		tay
		and #7
		tax
		tya
                .else
                ldx #7
                sbx #0
                .fi

		lsr pom2
		ror
		lsr pom2
		ror
		lsr pom2
		ror
		sta pom1
                lda find_free_buf_exp+1
		#orasta_a pom2
                .check CFG_OPEN_RAM, CFG_RAM
		.if SUPERCPU=1
		lda #1
		sta pom3
		lda [pom1]
		ora bm,x
		sta [pom1]
		.else
		ldy #0
		lda (pom1),y
		ora bm,x
		sta (pom1),y
		.fi
                rts

bm		.byte %10000000
		.byte %01000000
		.byte %00100000
		.byte %00010000
		.byte %00001000
		.byte %00000100
		.byte %00000010
		.byte %00000001
                .pend
;-------------------------------
;Position on file
;
XIT_posentry 	.proc
		jsr resolv_this_sector_exp_to_next_sector

in		lda resolv_entry_offs_exp
in2		lsr
		ror
		ror
		ror
		sta pom1
		lda #ram_exp_dir/2
		rol
		sta pom2
		.if SUPERCPU=1
		lda #1
		sta pom3
		.fi
		rts
                .pend
;-------------------------------
;Check nonexistent filename and if partition is writeable
;
XIT_wp		.proc
		.if SUPERCPU=1
                jsr OP_get_current_drive_type
                .else
		ldx current_drive_exp
                .fi
                lda drive_allowwrite_exp,x
                beq wp 		;write protected drive

		#ldx_l_a partition_currentp_exp
		lda partition_start_exp,x
		and #PATTR_WRITEABLE
	      	beq wp			;write protected partition

		lda resolv_dirattrib_exp
                and #FATTR_WRITE
wp              sec
		beq LWOP_reporterror_26_xit;write protected directory
                rts
		.pend			;X=partition_currentp_exp, C=1!!!
;-------------------------------
;Common prepare for S and RD
;
eraseprepare	.proc
		#ldx_l_a partition_currentp_exp
		lda partition_root_dir_exp,x
                asl
                .if FIND_FREE_DATA
		lda #FIND_FREE_DATA
                .else
                #lda0
                .fi
                sta find_free_mode_exp	;important!
                .if FIND_FREE_DATA
		#lda0
                .fi
                sta find_free_dirty_exp
                rol
                sta find_free_bam_exp

		ldx #3
		lda #255
ll      	sta scratch_now_exp,x
		dex
		bpl ll
                gmi partitionboundprepare
                .pend
;-------------------------------
;Is file locked?
;
XIT_is_locked	.proc
                ldx #MAX_BUFFERS-1
leu             lda buffer_logical_exp,x
                beq nopen		;buffer valid?
                lda buffer_drive_exp,x
                cmp current_drive_exp
                bne nopen		;on this drive?
                lda buffer_type_exp,x
                cmp #BUFFERMODE_RELATIVE
                beq dw
                cmp #BUFFERMODE_LINK
                beq dw
                cmp #BUFFERMODE_FILE
                bne nopen               ;used for file?
dw
		lda #>b_cfs_file_state_exp
		jsr buffer_subpart_cp2

		ldy #<(b_cfs_file_state_exp+cfs_file_treeroot_exp-cfs_file_info_backup_start_exp+3);check treeroot
-               cpy #<(b_cfs_file_state_exp+cfs_file_treeroot_exp-cfs_file_info_backup_start_exp+1)
                #lda_l_y_ direntry_f_pointer_exp-(<(b_cfs_file_state_exp+cfs_file_treeroot_exp-cfs_file_info_backup_start_exp))
		#eor_zp_y current_path
                bcs +
                and #$4f
+               bne nopen
		dey
		bcs -
                sec
                gcs LWOP_reporterror_60_xit;opened files can't be deleted!

nopen		dex
		bpl leu
                inx
		rts
                .pend
;-------------------------------
search_channel_A .proc
                and #$0f
exit    	ora #$60		;rts!
		sta pom2
                cmp #$62
                bge +
                sec
                gcs LWOP_reporterror_70_xit;error if not 2-14
+
		#ldx_l_a buffer_currentp_exp;channel 15's buffer
		lda buffer_logical_exp,x
		ldx #MAX_OPEN_FILES
lp		dex
		bmi exit+1
		cmp open_files_logical_exp,x
		bne lp
		lda open_files_device_exp,x;now we have the drivenumber we are on
		sta pom1
		ldx #MAX_OPEN_FILES
lp2		dex
		bmi exit+1
		lda pom1
		cmp open_files_device_exp,x;on this drive?
		bne lp2
		lda pom2
		cmp open_files_secondary_exp,x;channel correct?
		bne lp2
		lda open_files_logical_exp,x;file open?
		beq lp2
		gne search_buffer_A
		.pend
;V validate
;I initialize
;/ path (1581)
;M memory
;  MD mkdir
;  M-R memory read
;  M-W memory write
;  M-E memory execute
;B block
;  B-A block allocate
;  B-F block free
;  B-R block read
;  B-W block write
;  B-E block execute
;  B-P block pointer
;  B-r ??
;  B-w ??
;U user
;  U1 read
;  U2 write
;  U3-U8 user stuff
;  U9 identify
;  U: reset
;  U0 no operation, restore Ux jump table
;  U0>C ??
;  U0>T Teszt
;  U0>B Fast serial
;  U0>V0 Verify off
;  U0>V1 Verify on
;  U0>R Retry count
;  U0>S Interleave
;  U0>M0 1541 mode
;  U0>M1 1571 mode
;  U0>H0 Side 0
;  U0>H1 Side 1
;  U0>MR Burst memory read
;  U0>MW Burst memory write
;  U0>drivenumber
;P pointer
;& utility
;C
;  C copy
;  CP change partition
;  Cp change partition
;  CD chdir
;R
;  R rename
;  RD rmdir
;  R-H rename header
;  R-P rename partition
;S
;  S scratch
;  S-8 switch 8
;  S-9 switch 9
;  S-D switch default
;  S-C scsi command
;N new
;G get
;  GEOS ?
;  G-D ?
;  G-P get partition
;L lock
;W
;  W-0 Write protect off
;  W-1 Write protect on
;T time
;  T-RA read time ascii
;  T-RB read time bcd
;  T-RD read time decimal
;  T-WA write time ascii
;  T-WB write time bcd
;  T-WD write time decimal
;D duplicate

commands	.text "pcmsrl"
		.if SUPERCPU=1
commandslo	.word cmd_p
		.word cmd_c
		.word cmd_m
		.word cmd_s
                .word cmd_r
                .word cmd_l
                .else
commandslo	.byte <(cmd_p-1)
		.byte <(cmd_c-1)
		.byte <(cmd_m-1)
		.byte <(cmd_s-1)
                .byte <(cmd_r-1)
                .byte <(cmd_l-1)
commandshi	.byte >(cmd_p-1)
		.byte >(cmd_c-1)
		.byte >(cmd_m-1)
		.byte >(cmd_s-1)
                .byte >(cmd_r-1)
                .byte >(cmd_l-1)
                .fi
