;
; crosslnk.asm - Cross bank jumper
;
; Written by
;  Kajtar Zsolt <soci@c64.rulez.org>
;
;    This file is part of IDEDOS the IDE64 disk operating system
;    See README for copyright notice.
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
;
; Generated automatically. DO NOT EDIT!
;
			.if BANK=0
                        .assert CFG_8000_ROM | CFG_A000_ROM | CFG_D000_IO,CFG_8000_ROM | CFG_A000_ROM | CFG_D000_IO, CFG_8000_RAM | CFG_A000_RAM | CFG_A000_BASIC | CFG_D000_ROM
call_setup              sta bank_port1                  ;0000 -> 0006
                        #assert_cfg_open
			jsr cluster2sector              ;0003 <- BANK1
exitbank1               sta bank_port1                  ;0006
			rts				;0009
LWOP_disk_status        sta bank_port1                  ;000A -> 0010
                        #assert_cfg_16
			jsr iecin                       ;000D <- BANK1
                        #assert_cfg_open
                        sta bank_port1                  ;0010
			rts				;0013
LWOP_get_cmos_setup     sta bank_port1                  ;0014 -> 001A
                        #assert_cfg_16
			jsr ieclisten                   ;0017 <- BANK1
                        #assert_cfg_open
                        sta bank_port1                  ;001A
			rts				;001D
LWOP_read_clock         sta bank_port1                  ;001E -> 0024
                        #assert_cfg_16
			jsr iecout                      ;0021 <- BANK1
                        #assert_cfg_open
                        sta bank_port1                  ;0024
			rts				;0027
OP_loadingsavingmsg     sta bank_port1                  ;0028 -> 002E
                        #assert_cfg_16
			jsr iectalk                     ;002B <- BANK1
                        #assert_cfg_open
                        sta bank_port1                  ;002E
			rts				;0031
OP_load_loading_end     sta bank_port1                  ;0032 -> 0038
                        #assert_cfg_16
			jsr iectksa                     ;0035 <- BANK1
                        #assert_cfg_open
                        sta bank_port1                  ;0038
			rts				;003B
OP_save_zeropage_copy_filename_to_path sta bank_port1                  ;003C -> 0042
                        #assert_cfg_16
			jsr iecunlisten                 ;003F <- BANK1
                        #assert_cfg_open
                        sta bank_port1                  ;0042
			rts				;0045
OP_XIT_resolv_path_part_init sta bank_port1                  ;0046 -> 004C
                        #assert_cfg_16
			jsr iecuntalk                   ;0049 <- BANK1
                        #assert_cfg_open
                        sta bank_port1                  ;004C
			rts				;004F
update_filelen          sta bank_port1                  ;0050 -> 0056
                        #assert_cfg_16
			jsr iecsecond                   ;0053 <- BANK1
                        #assert_cfg_open
                        sta bank_port1                  ;0056
			rts				;0059
monitor                 sta bank_port3                  ;005A
			jsr fatdirectory                ;005D <- BANK3
exitbank3               sta bank_port3                  ;0060
newconsole              sta bank_port3                  ;0063
			.byte $ff,$ff,$ff		;0066
chs2lba                 sta bank_port2                  ;0069 -> 006F
			.byte $ff			;006C
                        #assert_cfg_16
			jmp hackedb2                    ;006D <- BANK3
                        #assert_cfg_open
			.byte $ff,$ff			;0070
			rts				;0072
			.byte $ff,$ff,$ff,$ff		;0073
			.byte $ff			;0077
                        #assert_cfg_16
			jmp mymisc                      ;0078 <- BANK3
                        #assert_cfg_open
find_free_space         sta bank_port2                  ;007B -> 0081
			.byte $ff			;007E
                        #assert_cfg_16
			jmp overt                       ;007F <- BANK3
                        #assert_cfg_open
			.byte $ff,$ff			;0082
			rts				;0084
			.byte $ff,$ff,$ff,$ff		;0085
			.byte $ff,$ff,$ff,$ff		;0089
find_free_start         sta bank_port2                  ;008D -> 0093
			.byte $ff,$ff,$ff,$ff		;0090
			.byte $ff,$ff			;0094
			rts				;0096
			.byte $ff,$ff,$ff,$ff		;0097
			.byte $ff,$ff,$ff,$ff		;009B
lba2chs                 sta bank_port2                  ;009F -> 00A5
			.byte $ff,$ff,$ff,$ff		;00A2
			.byte $ff,$ff			;00A6
			rts				;00A8
			.byte $ff,$ff,$ff,$ff		;00A9
			.byte $ff,$ff,$ff,$ff		;00AD
OP_atapi_command_multiplex sta bank_port2                  ;00B1 -> 00B7
			.byte $ff,$ff,$ff,$ff		;00B4
			.byte $ff,$ff			;00B8
			rts				;00BA
			.byte $ff,$ff,$ff,$ff		;00BB
			.byte $ff,$ff,$ff,$ff		;00BF
OP_XIT_do_command_channel sta bank_port2                  ;00C3 -> 00C9
cdrom_idleoff           sta bank_port3                  ;00C6 -> 00CC
			.byte $ff,$ff,$ff		;00C9
			rts				;00CC
			.byte $ff,$ff			;00CD
			rts				;00CF
pclink_chrinout         sta bank_port3                  ;00D0 -> 00D6
                        #assert_cfg_16
			jsr iecin                       ;00D3 <- BANK3
                        #assert_cfg_open
                        sta bank_port3                  ;00D6
			rts				;00D9
			.byte $ff			;00DA
			jsr OP_check_partition_selection;00DB <- BANK2
exitbank2               sta bank_port2                  ;00DE
			.byte $ff			;00E1
                        #assert_cfg_16
manager                 sta bank_port2                  ;00E2
                        #assert_cfg_open
			jsr OP_timestamp                ;00E5 <- BANK2
                        sta bank_port2                  ;00E8
			jsr OP_XIT_init_filesystem_from_disk;00EB <- BANK2
                        sta bank_port2                  ;00EE
			jsr search_buffer_A             ;00F1 <- BANK2
                        sta bank_port2                  ;00F4
			jsr XIT_flush_buf               ;00F7 <- BANK2
                        sta bank_port2                  ;00FA
			jsr OP_check_partition_selection;00FD <- BANK1
                        sta bank_port1                  ;0100
pclink_openclose        sta bank_port3                  ;0103 -> 0109
                        #assert_cfg_16
			jsr ieclisten                   ;0106 <- BANK3
                        #assert_cfg_open
                        sta bank_port3                  ;0109
			rts				;010C
pclink_status           sta bank_port3                  ;010D -> 0113
                        #assert_cfg_16
			jsr iecout                      ;0110 <- BANK3
                        #assert_cfg_open
                        sta bank_port3                  ;0113
			rts				;0116
XIT_dir_first           sta bank_port3                  ;0117 -> 011D
                        #assert_cfg_16
			jsr iectalk                     ;011A <- BANK3
                        #assert_cfg_open
                        sta bank_port3                  ;011D
			rts				;0120
XIT_dirlp2              sta bank_port3                  ;0121 -> 0127
                        #assert_cfg_16
			jsr iectksa                     ;0124 <- BANK3
                        #assert_cfg_open
                        sta bank_port3                  ;0127
			rts				;012A
newload                 sta bank_port1                  ;012B
                        #assert_cfg_16
			jsr iecunlisten                 ;012E <- BANK3
                        #assert_cfg_open
                        sta bank_port3                  ;0131
                        #assert_cfg_16
			jsr iecuntalk                   ;0134 <- BANK3
                        #assert_cfg_open
                        sta bank_port3                  ;0137
			.byte $ff			;013A
newread                 sta bank_port1                  ;013B
                        #assert_cfg_16
			jsr iecsecond                   ;013E <- BANK3
                        #assert_cfg_open
                        sta bank_port3                  ;0141
			jsr set_power_management_and_features;0144 <- BANK1
                        sta bank_port1                  ;0147
                        .assert CFG_8000_ROM | CFG_D000_IO | CFG_E000_ROM,CFG_8000_ROM | CFG_D000_IO | CFG_E000_ROM,CFG_8000_RAM | CFG_D000_ROM | CFG_E000_OPEN
			jsr LWNO_set_new314vect         ;014A <- BANK3
                        #assert_cfg_open
                        sta bank_port3                  ;014D
newwrite                sta bank_port1                  ;0150
			.byte $ff			;0153
                        .assert CFG_8000_ROM | CFG_A000_ROM | CFG_D000_IO, CFG_8000_ROM | CFG_A000_ROM | CFG_D000_IO, CFG_8000_RAM | CFG_A000_RAM | CFG_A000_BASIC | CFG_D000_ROM
			jsr LWOP_findunusedchannel      ;0154 <- BANK3
                        #assert_cfg_open
                        sta bank_port3                  ;0157
OP_XIT_execute_15command_open sta bank_port2                  ;015A -> 0160
			.byte $ff,$ff,$ff,$ff		;015D
			.byte $ff,$ff			;0161
			rts				;0163
			jsr LWOP_init_c128key           ;0164 <- BANK3
                        sta bank_port3                  ;0167
rewrite_file            sta bank_port2                  ;016A -> 0170
			.byte $ff,$ff,$ff,$ff		;016D
			.byte $ff,$ff			;0171
			rts				;0173
			jsr OP_check_partition_selection;0174 <- BANK3
                        sta bank_port3                  ;0177
seekappend              sta bank_port2                  ;017A -> 0180
			.byte $ff,$ff,$ff,$ff		;017D
			.byte $ff,$ff			;0181
			rts				;0183
			jsr OP_init_buffer_pointers     ;0184 <- BANK3
                        sta bank_port3                  ;0187
XIT_finalize_direntry   sta bank_port2                  ;018A -> 0190
			.byte $ff,$ff,$ff,$ff		;018D
			.byte $ff,$ff			;0191
			rts				;0193
			jsr OP_XIT_hdinit_2             ;0194 <- BANK3
                        sta bank_port3                  ;0197
XIT_flush_free_and_tree sta bank_port2                  ;019A -> 01A0
			.byte $ff,$ff,$ff		;019D
XIT_is_locked           sta bank_port2                  ;01A0 -> 01A6
			rts				;01A3
			.byte $ff,$ff			;01A4
XIT_load_tree           sta bank_port2                  ;01A6 -> 01AC
			rts				;01A9
			.byte $ff,$ff			;01AA
XIT_prealloc_dir_sector sta bank_port2                  ;01AC -> 01B2
			rts				;01AF
			.byte $ff,$ff			;01B0
XIT_read_a_sector       sta bank_port2                  ;01B2 -> 01B8
			rts				;01B5
			.byte $ff,$ff			;01B6
XIT_read_in_buffer      sta bank_port2                  ;01B8 -> 01BE
			rts				;01BB
			.byte $ff,$ff			;01BC
XIT_save_tree           sta bank_port2                  ;01BE -> 01C4
			rts				;01C1
			.byte $ff,$ff			;01C2
XIT_write_out_buffer    sta bank_port2                  ;01C4 -> 01CA
			rts				;01C7
			.byte $ff,$ff,$ff,$ff		;01C8
			.byte $ff			;01CC
			rts				;01CD
			jsr cluster2sector              ;01CE <- BANK3
                        sta bank_port3                  ;01D1
			.fi

			.if BANK=1
                        #assert_cfg_open
cluster2sector          sta bank_port0                  ;0000 -> 0006
			jsr call_setup                  ;0003 <- BANK0
exitbank0               sta bank_port0                  ;0006
			rts				;0009
                        #assert_cfg_16
iecin                   sta bank_port0                  ;000A -> 0010
                        #assert_cfg_open
			jsr LWOP_disk_status            ;000D <- BANK0
                        sta bank_port0                  ;0010
			rts				;0013
                        #assert_cfg_16
ieclisten               sta bank_port0                  ;0014 -> 001A
                        #assert_cfg_open
			jsr LWOP_get_cmos_setup         ;0017 <- BANK0
                        sta bank_port0                  ;001A
			rts				;001D
                        #assert_cfg_16
iecout                  sta bank_port0                  ;001E -> 0024
                        #assert_cfg_open
			jsr LWOP_read_clock             ;0021 <- BANK0
                        sta bank_port0                  ;0024
			rts				;0027
                        #assert_cfg_16
iectalk                 sta bank_port0                  ;0028 -> 002E
                        #assert_cfg_open
			jsr OP_loadingsavingmsg         ;002B <- BANK0
                        sta bank_port0                  ;002E
			rts				;0031
                        #assert_cfg_16
iectksa                 sta bank_port0                  ;0032 -> 0038
                        #assert_cfg_open
			jsr OP_load_loading_end         ;0035 <- BANK0
                        sta bank_port0                  ;0038
			rts				;003B
                        #assert_cfg_16
iecunlisten             sta bank_port0                  ;003C -> 0042
                        #assert_cfg_open
			jsr OP_save_zeropage_copy_filename_to_path;003F <- BANK0
                        sta bank_port0                  ;0042
			rts				;0045
                        #assert_cfg_16
iecuntalk               sta bank_port0                  ;0046 -> 004C
                        #assert_cfg_open
			jsr OP_XIT_resolv_path_part_init;0049 <- BANK0
                        sta bank_port0                  ;004C
			rts				;004F
                        #assert_cfg_16
iecsecond               sta bank_port0                  ;0050 -> 0056
                        #assert_cfg_open
			jsr update_filelen              ;0053 <- BANK0
                        sta bank_port0                  ;0056
			rts				;0059
			jsr check_wildcards             ;005A <- BANK2
exitbank2               sta bank_port2                  ;005D
linearaccess            sta bank_port2                  ;0060 -> 0066
			jsr LWOP_disk_status            ;0063 <- BANK3
exitbank3               sta bank_port3                  ;0066
			rts				;0069
			.byte $ff,$ff			;006A
			jsr check_wildtype              ;006C <- BANK2
                        sta bank_port2                  ;006F
OP_atapi_command_multiplex sta bank_port2                  ;0072 -> 0078
			jsr LWOP_read_clock             ;0075 <- BANK3
                        sta bank_port3                  ;0078
			rts				;007B
			.byte $ff,$ff			;007C
			jsr is_special_s                ;007E <- BANK2
                        sta bank_port2                  ;0081
XIT_init_drive          sta bank_port2                  ;0084 -> 008A
			jsr OP_get_partnum              ;0087 <- BANK3
                        sta bank_port3                  ;008A
			rts				;008D
			.byte $ff,$ff			;008E
			jsr LWOP_disk_status            ;0090 <- BANK2
                        sta bank_port2                  ;0093
XIT_load_tree           sta bank_port2                  ;0096 -> 009C
			jsr check_wildcards             ;0099 <- BANK3
                        sta bank_port3                  ;009C
			rts				;009F
			.byte $ff,$ff			;00A0
			jsr OP_get_partnum              ;00A2 <- BANK2
                        sta bank_port2                  ;00A5
XIT_read_a_sector       sta bank_port2                  ;00A8 -> 00AE
			jsr check_wildtype              ;00AB <- BANK3
                        sta bank_port3                  ;00AE
			rts				;00B1
			.byte $ff,$ff			;00B2
			jsr OP_short_path               ;00B4 <- BANK2
                        sta bank_port2                  ;00B7
find_free_sectors_blockwrite sta bank_port2                  ;00BA -> 00C0
			jsr OP_short_path               ;00BD <- BANK3
                        sta bank_port3                  ;00C0
			rts				;00C3
			.byte $ff,$ff			;00C4
			jsr OP_XIT_resolv_path          ;00C6 <- BANK2
                        sta bank_port2                  ;00C9
XIT_save_tree           sta bank_port2                  ;00CC -> 00D2
			.byte $ff,$ff,$ff,$ff		;00CF
			.byte $ff,$ff			;00D3
			rts				;00D5
			.byte $ff,$ff			;00D6
			jsr OP_XIT_resolv_path_part_init;00D8 <- BANK2
                        sta bank_port2                  ;00DB
OP_read_to_direntry     sta bank_port3                  ;00DE -> 00E4
			.byte $ff,$ff,$ff		;00E1
pclink_readwrite        sta bank_port3                  ;00E4 -> 00EA
			rts				;00E7
			.byte $ff,$ff			;00E8
XIT_dir_first           sta bank_port3                  ;00EA -> 00F0
			rts				;00ED
			.byte $ff,$ff			;00EE
XIT_dirlp2              sta bank_port3                  ;00F0 -> 00F6
			rts				;00F3
			.byte $ff,$ff			;00F4
pclink_load             sta bank_port3                  ;00F6 -> 00FC
			rts				;00F9
OP_check_partition_selection sta bank_port0                  ;00FA -> 0100
			.byte $ff,$ff			;00FD
			rts				;00FF
			.byte $ff,$ff,$ff		;0100
			rts				;0103
			.byte $ff,$ff,$ff,$ff		;0104
			.byte $ff,$ff,$ff,$ff		;0108
			.byte $ff,$ff,$ff,$ff		;010C
			.byte $ff,$ff,$ff,$ff		;0110
			.byte $ff,$ff,$ff,$ff		;0114
			.byte $ff,$ff,$ff,$ff		;0118
			.byte $ff,$ff,$ff,$ff		;011C
			.byte $ff,$ff,$ff,$ff		;0120
			.byte $ff,$ff,$ff,$ff		;0124
			.byte $ff,$ff,$ff		;0128
monitor                 sta bank_port3                  ;012B
			jmp newload                     ;012E <- BANK0
			.byte $ff,$ff,$ff,$ff		;0131
			.byte $ff,$ff,$ff		;0135
			jsr OP_XIT_resolv_path_part_init;0138 <- BANK3
                        sta bank_port3                  ;013B
			jmp newread                     ;013E <- BANK0
set_power_management_and_features sta bank_port0                  ;0141 -> 0147
			.byte $ff,$ff,$ff,$ff		;0144
			.byte $ff,$ff			;0148
			rts				;014A
			.byte $ff,$ff,$ff,$ff		;014B
			.byte $ff,$ff,$ff,$ff		;014F
			jmp newwrite                    ;0153 <- BANK0
			.fi

			.if BANK=2
                        #assert_cfg_open
channel15_cont          sta bank_port3                  ;0000 -> 0006
                        #assert_cfg_16
			jsr numtoasc16                  ;0003 <- BANK3
                        #assert_cfg_open
exitbank3               sta bank_port3                  ;0006
			rts				;0009
                        #assert_a000romioonly
getcconv                sta bank_port3                  ;000A -> 0010
                        #assert_cfg_open
			jsr OP_atapi_command_multiplex  ;000D <- BANK3
                        sta bank_port3                  ;0010
			rts				;0013
			.byte $ff,$ff,$ff		;0014
			jsr search_channel_A            ;0017 <- BANK3
                        sta bank_port3                  ;001A
			jsr XIT_init_drive              ;001D <- BANK3
                        sta bank_port3                  ;0020
			jsr XIT_init_drive2             ;0023 <- BANK3
                        sta bank_port3                  ;0026
			jsr XIT_read_a_sector           ;0029 <- BANK3
                        sta bank_port3                  ;002C
			jsr XIT_write_a_sector          ;002F <- BANK3
                        sta bank_port3                  ;0032
			.byte $ff,$ff,$ff,$ff		;0035
			.byte $ff,$ff,$ff,$ff		;0039
			.byte $ff,$ff,$ff,$ff		;003D
			.byte $ff,$ff,$ff,$ff		;0041
			.byte $ff,$ff,$ff,$ff		;0045
			.byte $ff,$ff,$ff,$ff		;0049
			.byte $ff,$ff,$ff,$ff		;004D
			.byte $ff,$ff,$ff,$ff		;0051
			.byte $ff,$ff			;0055
check_wildcards         sta bank_port1                  ;0057 -> 005D
			.byte $ff,$ff,$ff,$ff		;005A
			.byte $ff,$ff			;005E
			rts				;0060
			.byte $ff,$ff			;0061
			jsr linearaccess                ;0063 <- BANK1
exitbank1               sta bank_port1                  ;0066
check_wildtype          sta bank_port1                  ;0069 -> 006F
			jsr chs2lba                     ;006C <- BANK0
exitbank0               sta bank_port0                  ;006F
			rts				;0072
			.byte $ff,$ff			;0073
			jsr OP_atapi_command_multiplex  ;0075 <- BANK1
                        sta bank_port1                  ;0078
is_special_s            sta bank_port1                  ;007B -> 0081
			jsr find_free_space             ;007E <- BANK0
                        sta bank_port0                  ;0081
			rts				;0084
			.byte $ff,$ff			;0085
			jsr XIT_init_drive              ;0087 <- BANK1
                        sta bank_port1                  ;008A
LWOP_disk_status        sta bank_port1                  ;008D -> 0093
			jsr find_free_start             ;0090 <- BANK0
                        sta bank_port0                  ;0093
			rts				;0096
			.byte $ff,$ff			;0097
			jsr XIT_load_tree               ;0099 <- BANK1
                        sta bank_port1                  ;009C
OP_get_partnum          sta bank_port1                  ;009F -> 00A5
			jsr lba2chs                     ;00A2 <- BANK0
                        sta bank_port0                  ;00A5
			rts				;00A8
			.byte $ff,$ff			;00A9
			jsr XIT_read_a_sector           ;00AB <- BANK1
                        sta bank_port1                  ;00AE
OP_short_path           sta bank_port1                  ;00B1 -> 00B7
			jsr OP_atapi_command_multiplex  ;00B4 <- BANK0
                        sta bank_port0                  ;00B7
			rts				;00BA
			.byte $ff,$ff			;00BB
			jsr find_free_sectors_blockwrite;00BD <- BANK1
                        sta bank_port1                  ;00C0
OP_XIT_resolv_path      sta bank_port1                  ;00C3 -> 00C9
			jsr OP_XIT_do_command_channel   ;00C6 <- BANK0
                        sta bank_port0                  ;00C9
			rts				;00CC
			.byte $ff,$ff			;00CD
			jsr XIT_save_tree               ;00CF <- BANK1
                        sta bank_port1                  ;00D2
OP_XIT_resolv_path_part_init sta bank_port1                  ;00D5 -> 00DB
OP_check_partition_selection sta bank_port0                  ;00D8 -> 00DE
			.byte $ff,$ff,$ff		;00DB
			rts				;00DE
			.byte $ff,$ff			;00DF
			rts				;00E1
OP_timestamp            sta bank_port0                  ;00E2 -> 00E8
                        #assert_cfg_16
			jmp manager                     ;00E5 <- BANK0
                        #assert_cfg_open
OP_XIT_init_filesystem_from_disk sta bank_port0                  ;00E8 -> 00EE
			rts				;00EB
			.byte $ff,$ff			;00EC
search_buffer_A         sta bank_port0                  ;00EE -> 00F4
			rts				;00F1
			.byte $ff,$ff			;00F2
XIT_flush_buf           sta bank_port0                  ;00F4 -> 00FA
			rts				;00F7
			.byte $ff,$ff,$ff,$ff		;00F8
			.byte $ff			;00FC
			rts				;00FD
			.byte $ff,$ff,$ff,$ff		;00FE
			.byte $ff,$ff,$ff,$ff		;0102
			.byte $ff,$ff,$ff,$ff		;0106
			.byte $ff,$ff,$ff,$ff		;010A
			.byte $ff,$ff,$ff,$ff		;010E
			.byte $ff,$ff,$ff,$ff		;0112
			.byte $ff,$ff,$ff,$ff		;0116
			.byte $ff,$ff,$ff,$ff		;011A
			.byte $ff,$ff,$ff,$ff		;011E
			.byte $ff,$ff,$ff,$ff		;0122
			.byte $ff,$ff,$ff,$ff		;0126
			.byte $ff,$ff,$ff,$ff		;012A
			.byte $ff,$ff,$ff,$ff		;012E
			.byte $ff,$ff,$ff,$ff		;0132
			.byte $ff,$ff,$ff,$ff		;0136
			.byte $ff,$ff,$ff,$ff		;013A
			.byte $ff,$ff,$ff,$ff		;013E
			.byte $ff,$ff,$ff,$ff		;0142
			.byte $ff,$ff,$ff,$ff		;0146
			.byte $ff,$ff,$ff,$ff		;014A
			.byte $ff,$ff,$ff,$ff		;014E
			.byte $ff,$ff,$ff,$ff		;0152
			.byte $ff,$ff,$ff,$ff		;0156
			.byte $ff,$ff,$ff		;015A
			jsr OP_XIT_execute_15command_open;015D <- BANK0
                        sta bank_port0                  ;0160
			.byte $ff,$ff,$ff,$ff		;0163
			.byte $ff,$ff,$ff,$ff		;0167
			.byte $ff,$ff			;016B
			jsr rewrite_file                ;016D <- BANK0
                        sta bank_port0                  ;0170
			.byte $ff,$ff,$ff,$ff		;0173
			.byte $ff,$ff,$ff,$ff		;0177
			.byte $ff,$ff			;017B
			jsr seekappend                  ;017D <- BANK0
                        sta bank_port0                  ;0180
			.byte $ff,$ff,$ff,$ff		;0183
			.byte $ff,$ff,$ff,$ff		;0187
			.byte $ff,$ff			;018B
			jsr XIT_finalize_direntry       ;018D <- BANK0
                        sta bank_port0                  ;0190
			.byte $ff,$ff,$ff,$ff		;0193
			.byte $ff,$ff,$ff,$ff		;0197
			.byte $ff,$ff			;019B
			jsr XIT_flush_free_and_tree     ;019D <- BANK0
                        sta bank_port0                  ;01A0
			jsr XIT_is_locked               ;01A3 <- BANK0
                        sta bank_port0                  ;01A6
			jsr XIT_load_tree               ;01A9 <- BANK0
                        sta bank_port0                  ;01AC
			jsr XIT_prealloc_dir_sector     ;01AF <- BANK0
                        sta bank_port0                  ;01B2
			jsr XIT_read_a_sector           ;01B5 <- BANK0
                        sta bank_port0                  ;01B8
			jsr XIT_read_in_buffer          ;01BB <- BANK0
                        sta bank_port0                  ;01BE
			jsr XIT_save_tree               ;01C1 <- BANK0
                        sta bank_port0                  ;01C4
			jsr XIT_write_out_buffer        ;01C7 <- BANK0
                        sta bank_port0                  ;01CA
			.fi

			.if BANK=3
                        #assert_cfg_16
numtoasc16              sta bank_port2                  ;0000 -> 0006
                        #assert_cfg_open
			jsr channel15_cont              ;0003 <- BANK2
exitbank2               sta bank_port2                  ;0006
			rts				;0009
OP_atapi_command_multiplex sta bank_port2                  ;000A -> 0010
                        #assert_a000romioonly
			jsr getcconv                    ;000D <- BANK2
                        #assert_cfg_open
                        sta bank_port2                  ;0010
			rts				;0013
search_channel_A        sta bank_port2                  ;0014 -> 001A
			.byte $ff,$ff,$ff		;0017
XIT_init_drive          sta bank_port2                  ;001A -> 0020
			rts				;001D
			.byte $ff,$ff			;001E
XIT_init_drive2         sta bank_port2                  ;0020 -> 0026
			rts				;0023
			.byte $ff,$ff			;0024
XIT_read_a_sector       sta bank_port2                  ;0026 -> 002C
			rts				;0029
			.byte $ff,$ff			;002A
XIT_write_a_sector      sta bank_port2                  ;002C -> 0032
			rts				;002F
			.byte $ff,$ff,$ff,$ff		;0030
			.byte $ff			;0034
			rts				;0035
			.byte $ff,$ff,$ff,$ff		;0036
			.byte $ff,$ff,$ff,$ff		;003A
			.byte $ff,$ff,$ff,$ff		;003E
			.byte $ff,$ff,$ff,$ff		;0042
			.byte $ff,$ff,$ff,$ff		;0046
			.byte $ff,$ff,$ff,$ff		;004A
			.byte $ff,$ff,$ff,$ff		;004E
			.byte $ff,$ff,$ff,$ff		;0052
			.byte $ff,$ff,$ff,$ff		;0056
fatdirectory            sta bank_port0                  ;005A -> 0060
			jmp monitor                     ;005D <- BANK0
LWOP_disk_status        sta bank_port1                  ;0060 -> 0066
			rts				;0063
			.byte $ff,$ff			;0064
			jmp newconsole                  ;0066 <- BANK0
			rts				;0069
                        #assert_cfg_16
hackedb2                sta bank_port0                  ;006A
                        #assert_cfg_open
			.byte $ff,$ff,$ff,$ff		;006D
			.byte $ff			;0071
LWOP_read_clock         sta bank_port1                  ;0072 -> 0078
                        #assert_cfg_16
mymisc                  sta bank_port0                  ;0075
                        #assert_cfg_open
			.byte $ff,$ff,$ff		;0078
			rts				;007B
                        #assert_cfg_16
overt                   sta bank_port0                  ;007C
                        #assert_cfg_open
			.byte $ff,$ff,$ff,$ff		;007F
			.byte $ff			;0083
OP_get_partnum          sta bank_port1                  ;0084 -> 008A
			.byte $ff,$ff,$ff,$ff		;0087
			.byte $ff,$ff			;008B
			rts				;008D
			.byte $ff,$ff,$ff,$ff		;008E
			.byte $ff,$ff,$ff,$ff		;0092
check_wildcards         sta bank_port1                  ;0096 -> 009C
			.byte $ff,$ff,$ff,$ff		;0099
			.byte $ff,$ff			;009D
			rts				;009F
			.byte $ff,$ff,$ff,$ff		;00A0
			.byte $ff,$ff,$ff,$ff		;00A4
check_wildtype          sta bank_port1                  ;00A8 -> 00AE
			.byte $ff,$ff,$ff,$ff		;00AB
			.byte $ff,$ff			;00AF
			rts				;00B1
			.byte $ff,$ff,$ff,$ff		;00B2
			.byte $ff,$ff,$ff,$ff		;00B6
OP_short_path           sta bank_port1                  ;00BA -> 00C0
			.byte $ff,$ff,$ff,$ff		;00BD
			.byte $ff,$ff			;00C1
			rts				;00C3
			.byte $ff,$ff,$ff,$ff		;00C4
			.byte $ff			;00C8
			jsr cdrom_idleoff               ;00C9 <- BANK0
exitbank0               sta bank_port0                  ;00CC
			.byte $ff			;00CF
                        #assert_cfg_16
iecin                   sta bank_port0                  ;00D0 -> 00D6
                        #assert_cfg_open
			jsr pclink_chrinout             ;00D3 <- BANK0
                        sta bank_port0                  ;00D6
			rts				;00D9
			.byte $ff,$ff,$ff,$ff		;00DA
			.byte $ff,$ff,$ff		;00DE
			jsr OP_read_to_direntry         ;00E1 <- BANK1
exitbank1               sta bank_port1                  ;00E4
			jsr pclink_readwrite            ;00E7 <- BANK1
                        sta bank_port1                  ;00EA
			jsr XIT_dir_first               ;00ED <- BANK1
                        sta bank_port1                  ;00F0
			jsr XIT_dirlp2                  ;00F3 <- BANK1
                        sta bank_port1                  ;00F6
			jsr pclink_load                 ;00F9 <- BANK1
                        sta bank_port1                  ;00FC
			.byte $ff,$ff,$ff,$ff		;00FF
                        #assert_cfg_16
ieclisten               sta bank_port0                  ;0103 -> 0109
                        #assert_cfg_open
			jsr pclink_openclose            ;0106 <- BANK0
                        sta bank_port0                  ;0109
			rts				;010C
                        #assert_cfg_16
iecout                  sta bank_port0                  ;010D -> 0113
                        #assert_cfg_open
			jsr pclink_status               ;0110 <- BANK0
                        sta bank_port0                  ;0113
			rts				;0116
                        #assert_cfg_16
iectalk                 sta bank_port0                  ;0117 -> 011D
                        #assert_cfg_open
			jsr XIT_dir_first               ;011A <- BANK0
                        sta bank_port0                  ;011D
			rts				;0120
                        #assert_cfg_16
iectksa                 sta bank_port0                  ;0121 -> 0127
                        #assert_cfg_open
			jsr XIT_dirlp2                  ;0124 <- BANK0
                        sta bank_port0                  ;0127
			rts				;012A
                        #assert_cfg_16
iecunlisten             sta bank_port0                  ;012B -> 0131
                        #assert_cfg_open
			jmp monitor                     ;012E <- BANK1
                        #assert_cfg_16
iecuntalk               sta bank_port0                  ;0131 -> 0137
                        #assert_cfg_open
			rts				;0134
OP_XIT_resolv_path_part_init sta bank_port1                  ;0135 -> 013B
			.byte $ff,$ff			;0138
			rts				;013A
                        #assert_cfg_16
iecsecond               sta bank_port0                  ;013B -> 0141
                        #assert_cfg_open
			rts				;013E
			.byte $ff,$ff,$ff,$ff		;013F
			.byte $ff			;0143
			rts				;0144
			.byte $ff,$ff			;0145
                        .assert CFG_8000_ROM | CFG_D000_IO | CFG_E000_ROM,CFG_8000_ROM | CFG_D000_IO | CFG_E000_ROM,CFG_8000_RAM | CFG_D000_ROM | CFG_E000_OPEN
LWNO_set_new314vect     sta bank_port0                  ;0147 -> 014D
                        #assert_cfg_open
			.byte $ff,$ff,$ff,$ff		;014A
			.byte $ff,$ff			;014E
			rts				;0150
                        .assert CFG_8000_ROM | CFG_A000_ROM | CFG_D000_IO, CFG_8000_ROM | CFG_A000_ROM | CFG_D000_IO, CFG_8000_RAM | CFG_A000_RAM | CFG_A000_BASIC | CFG_D000_ROM
LWOP_findunusedchannel  sta bank_port0                  ;0151 -> 0157
                        #assert_cfg_open
			.byte $ff,$ff,$ff,$ff		;0154
			.byte $ff,$ff			;0158
			rts				;015A
			.byte $ff,$ff,$ff,$ff		;015B
			.byte $ff,$ff			;015F
LWOP_init_c128key       sta bank_port0                  ;0161 -> 0167
			.byte $ff,$ff,$ff,$ff		;0164
			.byte $ff,$ff			;0168
			rts				;016A
			.byte $ff,$ff,$ff,$ff		;016B
			.byte $ff,$ff			;016F
OP_check_partition_selection sta bank_port0                  ;0171 -> 0177
			.byte $ff,$ff,$ff,$ff		;0174
			.byte $ff,$ff			;0178
			rts				;017A
			.byte $ff,$ff,$ff,$ff		;017B
			.byte $ff,$ff			;017F
OP_init_buffer_pointers sta bank_port0                  ;0181 -> 0187
			.byte $ff,$ff,$ff,$ff		;0184
			.byte $ff,$ff			;0188
			rts				;018A
			.byte $ff,$ff,$ff,$ff		;018B
			.byte $ff,$ff			;018F
OP_XIT_hdinit_2         sta bank_port0                  ;0191 -> 0197
			.byte $ff,$ff,$ff,$ff		;0194
			.byte $ff,$ff			;0198
			rts				;019A
			.byte $ff,$ff,$ff,$ff		;019B
			.byte $ff,$ff,$ff,$ff		;019F
			.byte $ff,$ff,$ff,$ff		;01A3
			.byte $ff,$ff,$ff,$ff		;01A7
			.byte $ff,$ff,$ff,$ff		;01AB
			.byte $ff,$ff,$ff,$ff		;01AF
			.byte $ff,$ff,$ff,$ff		;01B3
			.byte $ff,$ff,$ff,$ff		;01B7
			.byte $ff,$ff,$ff,$ff		;01BB
			.byte $ff,$ff,$ff,$ff		;01BF
			.byte $ff,$ff,$ff,$ff		;01C3
			.byte $ff,$ff,$ff,$ff		;01C7
cluster2sector          sta bank_port0                  ;01CB -> 01D1
			.byte $ff,$ff,$ff,$ff		;01CE
			.byte $ff,$ff			;01D2
			rts				;01D4
			.fi

