;
; dolphindos.asm - DolphinDOS compatible parallel routines
;
; Written by
;  Kajtar Zsolt <soci@c64.rulez.org>
;
;    This file is part of IDEDOS the IDE64 disk operating system
;    See README for copyright notice.
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
JIFFYDOS_ROM	= 1

		#assert_cfg_16

		.if (DOLPHINDOS_ACCEL=1)

iectalk		.proc			;ed09
		ora #$40
                .byte SKIP2
ieclisten	.proc			;ed0c
		ora #$20

ed11            .proc
                pha
                bit SerialOutBufFlag
                bpl jj
                sec
                ror SerialEOI
                jsr ed40
                lsr SerialOutBufFlag
                .if JIFFYDOS_ROM=0
                lsr SerialEOI
                .fi
jj              pla
                sta SerialOutBuf
                sei
                jsr restore_parallel_port

                .if JIFFYDOS_ROM=1
                #stz_a SerialEOI
                .fi
                lda #$08
                #orasta_a $dd00

ed36		.proc
		.if JIFFYDOS_ROM=1
                lda $dc0c               ;f96f
                bpl $ed36
                .fi
                sei
		jsr $ee8e		;clklo
		jsr $ee97		;datahi
		jsr $eeb3		;1ms delay
ed40            .proc
		sei
                lda $dc0c               ;f96f
                bpl normal
                lda $dd00
                bmi devicenotp
                and #$ef
                sta $dd00
                stx $a5
                bit SerialEOI
                bpl jd
-               bit $dd00
                bpl -
                ldx #$1e
ce              lda $dd00
                bpl jd
                dex
                bne ce
                geq zc

jd              lda $dd00
                bpl jd
                ldx SerialOutBuf
                stx $dd01
                ldx #$1e
zc              ora #$10
                sta $dd00
                lda #$03
cr              dex
                bmi f9b7                ;timeout
                bit $dd00
                bmi cr
		ldx $a5
		clc
                cli
                rts

normal
		.if JIFFYDOS_ROM=1
		jmp ($ed1a)
                .else
                jmp $ed44
                .fi

devicenotp     	lda #$80

f9b7		.proc
		ldx $a5
		jsr restore_parallel_port
                jmp $edb2		;status
		.pend

iecsecond	.proc			;edb9
                jsr dolphout
		jmp $edbe		;atnhi
                .pend

iectksa		.proc			;edc7
                jsr dolphout
                sei
                bit $dc0c
                bpl if
                inc $dd03
if              jsr $eea0		;datalo
                jmp $edd0
                .pend

iecout		.proc
                bit SerialOutBufFlag
                bmi ir
                sec
                ror SerialOutBufFlag
                gmi zx

ir              pha
                jsr ed40
                pla
zx              sta SerialOutBuf
                clc
                rts
		.pend

iecuntalk	.proc
                sei
                lda #$18
                #orasta_a $dd00         ;clklo, atnlo
                lda #$5f
                .byte SKIP2

iecunlisten     .proc
                lda #$3f
                jsr ed11
                jmp $ee03
                .pend

iecin		.proc
		sei
                bit $dc0c
                bpl normal
                stx $a5
-               bit $dd00
                bvc -
                lda $dd00
                and #$df
                sta $dd00
                ldx #5
ii              bit $dd00
                bvc ke
                dex
                bne ii
                jsr $eea0		;datalo
                lda #$40
                jsr $fe1c		;set status
                jsr $ee97		;datahi
                ldx #$05
ii2             bit $dd00
                bvc ke
                dex
                bne ii2
                lda #$02
                gne f9b7

ke              ldx $dd01
                ora #$20
                sta $dd00
                stx SerialInBuf
                ldx $a5
                lda SerialInBuf
                clc
                cli
                rts

normal
		.if JIFFYDOS_ROM=1
		jmp $ee13               ;normal iecin because of jiffydos rom...
                .else
                #stz_a $a5              ;normal iecin
		jsr $ee85		;clkhi
                jmp $ee1b
                .fi

                .pend

dolphout       	.proc			;f8dd
		sta SerialOutBuf
;                pha
                jsr ed36
;                sei
;                pla
;                and #$f0
;                cmp #$e0		;close?
;                beq close
                stx $a5
                ldx #$19
                lda #$10
                bit $dd0d
ee              dex
                beq sd
                bit $dd01
                bit $dd0d
                beq ee
                lda #128
                sta $dc0c

                lda $dd03
                sta $0296
                lda #$ff
                sta $dd03
                lda $dd01
                sta $0295

sd              ldx $a5
		cli
                rts
		.pend

restore_parallel_port .proc
		bit $dc0c
                bpl ss

		pha
                #stz_a $dc0c
                lda $0296
                sta $dd03
                lda $0295
                sta $dd01
                pla
ss              rts
		.pend

                .fi
