;
; fastload.asm - Fastload for 1541/1570/1571/1581
;
; Written by
;  Kajtar Zsolt <soci@c64.rulez.org>
;
;    This file is part of IDEDOS the IDE64 disk operating system
;    See README for copyright notice.
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
		.assert CFG_8000_ROM | CFG_A000_ROM | CFG_D000_IO, CFG_8000_ROM | CFG_A000_ROM | CFG_D000_IO, CFG_8000_RAM | CFG_A000_RAM | CFG_A000_BASIC | CFG_D000_ROM
fastloadinit 	.proc
		#lda0
		.byte SKIP2

fastsaveinit	.proc
		#assert_kernal_io
iout		= $eddd
iunlisten	= $edfe
italk		= $ed09
itksa		= $edc7
iuntalk		= $edef
iin		= $ee13
ilisten		= $ed0c
isecond		= $edb9

		.assert CFG_8000_ROM | CFG_A000_ROM | CFG_D000_IO, CFG_8000_ROM | CFG_A000_ROM | CFG_D000_IO, CFG_8000_RAM | CFG_A000_RAM | CFG_A000_BASIC | CFG_D000_ROM

		lda #6
		sta pom1

                #sta_cfg_open
                lda setup_atribut_exp
                #sta_cfg_16
                and #CMOS_TURBO
                beq nemjo2+1

                sty pom4

                jsr listen
		ldx #5
smr		lda mr,x
		jsr iout
		dex
		bpl smr
                jsr iunlisten	;unlisten

                lda pom4
                jsr italk	;talk
                lda #$6f
                jsr itksa	;tksa
                jsr iin
                tax
                jsr iin
                tay
                jsr iin
                jsr iuntalk		;untalk

		lda #2
                cpx #$a0
                bne qq
                cpy #$ea
                beq jo
qq		lda #5
                cpx #$24
                bne nemjox
                cpy #$af
                beq jo

nemjox	 	lda pom4
		jsr iectalk		;talk
nemjo2		lda #$60		;rts!!!
		jmp iectksa		;tksa

jo		clc
		adc pom1
		tax
		ldy #3
-		lda cucc,x
		sta pom1-1,y
                dex
                dey
                bne -
                lda pom3
                beq nemjo2+1
sloop		jsr listen

		ldx #2
smw		lda mw,x
		jsr iout
		dex
		bpl smw
		tya
		jsr iout
                lda #5
		jsr iout
                tya
                eor #255
                cmp #36
                bcc +
		lda #35
+               tax
		jsr iout

slp		lda (pom1),y
		jsr iout
		iny
                dex
		bne slp
		jsr iunlisten	;unlisten

		cpy pom3
		bcc sloop
		jsr listen

		ldy #17
-		lda me,y
		jsr iout
		dey
		bpl -
                lda $dd00
                and #3
                jsr iout
                #sta_cfg_open
                lda TV_machine_type_exp
                #sta_cfg_16
                jsr iout
		jsr iunlisten	;unlisten
                lda #$23
                sta $dd00
                sec
                ror next_sector
                ldx #0
-               dex
                bne -

                rts

listen		lda pom4
		jsr ilisten	;listen
		lda #$6f
		jmp isecond	;second
;---------------------------------------
		.assert CFG_8000_ROM,CFG_8000_ROM, CFG_8000_RAM
cucc		.word drive154171
		.byte driveend-drive154171
                .word drive1581
		.byte driveend2-drive1581
                .word drive1541save
                .byte driveend3-drive1541save
                .word 0
                .byte 0

mw		.text "w-m"
mr		.text $02,$ff,$fc,"r-m"

me		.byte $00,$08,$02,$0a
                .byte $04,$0c,$06,$0e
                .byte $01,$09,$03,$0b
                .byte $05,$0d,$07,$0f
		.text "3u"
;---------------------------------------
		.pend

                .cpu 6502i

drive154171	.proc

		.logical $500

p1		= $06
p2		= $07
p3		= $0a
p4		= $0b

start	        sei
		lda #$08
		sta $1800
		lda $19
		sta $09
		lda $18
		sta $08

-		lda $1800
                lsr
                bcs -

                lda $31
                cmp #$04
                bne read

loop		lda $1801
                pha
                and #$df
                sta $1801
;-----------------------------------
tk		ldy #4
                lax $401
                sta $09;$81
                lda $400
                sta $08
                bne hto
                tya
                clc
                sbc $09;$81
                inx
                stx $30
                beq ntnk
                dec $31
ntnk            tay
hto
 		lda $1800
                and #$60
                sta p3
                ora #$0d
                sta p2
                jsr $e9a5	;1800 or 2
                eor #$0d
                sta $1800
                jsr $fef3	;wait
sndlp		lax ($30),y
                lsr
                lsr
                lsr
                lsr
                sta p1
                lda #$0f
                sbx #0
                lda $202,x
                ldx p3
                stx $1800
-               cpx $1800
                beq -
                sta $1800
                asl
                and #$0f
                nop
                sta $1800
                ldx p1
                lda $202,x
                sta $1800
                asl
                and #$0f
                iny
                sta $1800
		bne sndlp
                nop
                ldx p2
		stx $1800
nn              cpx $1800
                bcc vv
                bne nn

		lda #2
                sta tk+1
;-----------------------------------
                lda $08
		beq vv
		pla
                sta $1801

read		ldy #20
lp2		lda #$80
		sta $01
		cli
-		lda $01
		bmi -
		sei
		cmp #$01
		beq loop
		dey
                bne lp2
                lda #$23
                sta $26c
                rts

vv 		jsr ee
		pla
                sta $1801
                rts

ee		jsr xj
                jsr xj
                jsr $e9ae	;1800 or 8
xj              ldx #20
-               dex
                bne -
                jmp $e9b7	;1800 and ~8

                .cerror *>$5ff

		.here

                .pend
driveend


drive1581	.proc

		.logical $500

p1		= $0b
p2		= $0c
p3		= $0d
p4		= $0e

start	        sei
		lda #$08
		sta $4001

-		lda $4001
                lsr
                bcs -

                lda $49
                cmp #$08
                beq loop
                asl
                tax
                lda $b-6,x
                sta $15
                lda $c-6,x
                sta $16
                gcc read

loop
;-----------------------------------
tk		ldy #4
                lax $801
                sta $16;$81
                lda $800
                sta $15
                bne hto
                tya
                clc
                sbc $16;$81
                inx
                stx $48
                beq ntnk
                dec $49
ntnk            tay
hto
 		lda $4001
                and #$60
                sta p3
                ora #$0d
                sta p2
                ora #2
                sta $4001
                eor #$0d
                sta $4001
                ldx #14
-               dex
                bne -
sndlp		lda ($48),y
		tax
                lsr
                lsr
                lsr
                lsr
                sta p1
                txa
                and #$0f
                tax
                lda $202,x
                ldx p3
                jsr e3ae
                stx $4001
                nop
                nop
-               cpx $4001
                beq -
                pha
                pla
                nop
                sta $4001
                asl
                and #$0f
                pha
                pla
                ldx p1
                ora #$10
                sta $4001
                lda $202,x
                pha
                pla
                pha
                pla
                sta $4001
                asl
                and #$0f
                ora #$10
                cmp (0,x)
                nop
                nop
                iny
                sta $4001
		bne sndlp
                lda @wp2
                jsr e3b7
		sta $4001
nn              bit $4001
                cmp $4001
                bcc vv
                bne nn

		lda #2
                sta tk+1
;-----------------------------------
                lda $15
		beq vv

read		ldy #20
lp2		lda #$80
		sta $07
		cli
-		lda $07
		bmi -
		sei
		beq loop
		dey
                bne lp2
                lda #$23
                sta $2ab
                rts

vv 		jsr xj
                jsr xj
                lda $4001
                ora #$08
                sta $4001
xj              ldx #20*2+2
-               dex
                bne -
                lda $4001
                and #$f7
                sta $4001
                rts

e3ae		jsr e3b7
e3b7            rts

		.cerror *>$5ff

		.here

                .pend
driveend2

drive1541save   .proc

		.logical $0500

cbf		=$94
track		=$80
sector		=$81
buffn2  	=$05

		jmp start
		lda buffn2
		tax
		lsr a
		adc #$03
		sta cbf+1
		sta $31
		txa
		adc #$06
		sta $32
loop		jsr getbyte
 		beq nlast
		tax
		stx sector
		inx
		stx endm+1
		lda #$00
		sta track
		geq ki

nlast   	lda $02fc	;free blocks hi
		ora $02fa       ;free blocks lo
		bne ok
		lda #$72
		jmp $f969	;error

ok		jsr $f11e	;find free space
ki      	ldy #$00
		sty cbf
		lda track
		sta (cbf),y
		iny
		lda sector
		sta (cbf),y
		iny
lop     	jsr getbyte
		sta ($30),y
		iny
endm    	cpy #0
		bne lop
		jsr $0150
		inc $b6		;rec lo
		bne +
		inc $bc		;rec hi
+		ldx buffn2
		lda sector
		sta $07,x
		lda track
		cmp $06,x
		beq loop
		sta $06,x
		jmp $f418	;ok

getbyte 	lda #$01
		sta $1800
-		bit $1800
		bne -
                lda $213        ;ntsc: cmp (0,x)
                bne +
+		lda $1800
		asl a
		nop
		ldx #$08
		ora $1800
		asl a
		asl a
		asl a
		asl a
		sta @w$c0
		lda $1800
                cmp (0,x)
		asl a
		ora $1800
		stx $1800
                and #$0f
		ora $c0
		rts

start          	lda #8
		sta $1800
	       	sta 105
		inc $500
		ldx #$64
kqk		lda $f574,x
		sta $014f,x
		dex
		bne kqk
		lda #$60
		sta $01b4
		inx
		stx $82
		stx $83
		jsr $df95
		sta othererr+1
		asl a
		sta buffn2
		tax
		lda #$40
		sta $02f9	;don't write bam
slop 		lda $06,x
		beq last
		sta $0a
		lda #$e0
		sta $02
-		lda $02
		bmi -
		cmp #$02
		bcc slop
		cmp #$72
		bne othererr
		jmp $c1c8	;???

othererr	ldx #0
		jmp $e60a	;error msg

last		ldx #$09
kxi		lda mod-1,x
		sta $014f,x
		dex
		bne kxi
		jmp $0150

mod     	jsr $dba5
		jsr $eef4
		jmp $d227

		.cerror *>$5ff

		.here

                .pend
driveend3
                .cpu default

