;
; fat.asm - FAT misc routines
;
; Written by
;  Kajtar Zsolt <soci@c64.rulez.org>
;
;    This file is part of IDEDOS the IDE64 disk operating system
;    See README for copyright notice.
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
		#assert_cfg_open

euiuei		= fatdirectory
euiuei2		= cluster2sector

fatdirectory	.proc
		.if SUPERCPU=1
		dec a
                .else
		dex
                .fi
		bne fatdir2
                ldx #15
		lda #32
-               sta direntry_name_exp,x
                dex
                bpl -
                jsr dir
                ldx #3
-		lda ku,x
		sta direntry_pointer_exp,x
                sta direntry_size_exp,x
                dex
                bpl -

                lda #FTYPE_DIR|FATTR_READ
                sta direntry_attrib_exp
		lda #DIRMODE_FAT2
		sta direntry_mode_exp
		lda #16
		sta direntry_number_exp
		rts
ku              .byte $40,0,0,1

fatdir2		ldx #240
-		lda data_g		;Get name ($02)
		#lda_low_reg
		sta direntry_name_exp-240,x
		inx
		lda hig_reg
		sta direntry_name_exp-240,x
		inx
		bne -

		ldx #2
-		lda direntry_name_exp+8,x
                sta direntry_filetype_exp,x
                dex
                bpl -

		ldx #248
		lda direntry_name_exp
                bne noo
                sta next_sector
                sta next_sector+1	;last sector
                sta next_sector+2	;no check for maximal direntry sector count reached!!!!!!!
                sta next_sector+3
                geq no

noo             cmp #$e5
                beq longnone
                cmp #$05
                bne +
                lda #$e5
+               sta direntry_name_exp

                lda direntry_name_exp+11;00ADVSHR
                cmp #$0f
                beq longnone
                lsr	;r
                php
                lsr	;h
                lsr	;s
                lsr	;v
                php
                lsr	;d
		lda #FATTR_EXEC | FTYPE_NORMAL | FATTR_READ
                bcc nok

		jsr dir
		ldx #248+3

                lda #FATTR_EXEC | FTYPE_DIR | FATTR_READ
nok             plp
        	bcs ko
                ora #FATTR_CLOSED
ko        	plp
        	bcs no
                ora #FATTR_WRITE | FATTR_DELETE
                .byte SKIPLDA0
longnone	#lda0
no		sta direntry_attrib_exp

                lda direntry_name_exp+11;00ADVSHR
                lsr	;r
                lsr	;h
                #lda0
                ror			;hidden
                sta direntry_pointer_exp

                lda #32
-		sta direntry_name_exp-240,x
		inx
                bne -

                bit data_g		;cdate
                bit data_g              ;adate

                lda data_g
                #lda_low_reg
                sta direntry_pointer_exp+1
                lda hig_reg
                and #$0f
                ora direntry_pointer_exp+0
                sta direntry_pointer_exp+0

                bit data_g		;mtime
                bit data_g		;mdate

                lda data_g
                #lda_low_reg
                sta direntry_pointer_exp+3
                lda hig_reg
                sta direntry_pointer_exp+2
                .if FAST_DATA_TRANSFERS
                ora direntry_pointer_exp+3
                .else
                ora low_reg
                .fi
                ora direntry_pointer_exp+1
		bne jd
                lda direntry_pointer_exp
                and #$0f
                bne jd
                tay
                #ldx_l_a partition_currentp_exp
-		lda partition_root_dir_exp,x
                #sta_l_y_ direntry_pointer_exp
                inx
                iny
                cpy #4
                bcc -

jd              ldx #252
-		lda data_g
                #lda_low_reg
                sta direntry_size_exp-252,x
                inx
                lda hig_reg
                sta direntry_size_exp-252,x
                inx
                bne -

                ldx #15
                #txy_a
                jsr killpad

		lda direntry_number_exp
                bne tp

                lda next_sector
                jsr next_sector0.in
                beq tp

                #inc_l_a direntry_fat_dirsectors_exp

                jsr sector2cluster
                bcc rootd

                lda next_sector+3
                cmp #2
                bcs nk
                lda next_sector+2
                ora next_sector+1
                ora next_sector
                bne nk
rootd           ldx #1
                stx next_sector+3
                dex
                stx next_sector+2
                stx next_sector+1
                stx next_sector
                geq tp

nk      	#ldx_l_a partition_currentp_exp
                lda direntry_fat_dirsectors_exp
                eor partition_fat_sectperclust_exp,x
                bne tp
                sta direntry_fat_dirsectors_exp

		jsr wait_busy;bit status_g;                jsr XIT_nomoreread	;-=> error
                jsr LWOP_reporterror_read_xit

                jsr XIT_nextcluster
tp
                ldx #direntry_filetype_exp-direntry_name_exp+2
                ldy #3

killpad         lda direntry_name_exp,x
                eor #$20
                bne njo
                sta direntry_name_exp,x
                dex
                dey
                bne killpad
njo		rts

dir             ldx #2
hh              lda dirtxt,x
                sta direntry_filetype_exp,x
                dex
                bpl hh
		rts
dirtxt		.text "dir"
		.pend

cluster2sector	.proc
		pha
                lda next_sector+3
                eor #1
                ora next_sector+2
                ora next_sector+1
                ora next_sector
                bne nrootdir
                lda partition_currentp_exp
                ora #3
                tax
                pla
                ldy #3
                clc
                .byte SKIPLDA0
-		#lda0
                adc partition_fat_root_dir_exp,x
                sta next_sector,y
                dex
                dey
                bpl -
                ldx #4
-		lda szam,x
                pha
                dex
                bpl -
                gmi ou

nrootdir       	lda partition_currentp_exp
                ora #3
                tay

                #lda_l_y_x partition_fat_sectperclust_exp-3
iiu             lsr
                beq bbb
                ldx #3
-		rol next_sector,x
                dex
                bpl -
                gmi iiu
bbb

		pla
                ora next_sector+3
                sta next_sector+3

		#tyx_a

		lda szam+4
                pha
                ldy #3
                clc
-		lda szam,y
        	pha
		lda next_sector,y
		adc partition_fat_data_exp,x
                sta next_sector,y
                dex
                dey
                bpl -
ou
                ldx #3
                ldy #0
-		lda next_sector,x
                sta szam,y
                iny
                dex
                bpl -

                jsr fatlba2chs

		ldx #0
-		pla
        	sta szam,x
                inx
                cpx #5
                bne -
		rts
                .pend

sector2cluster	.proc
                ldx #4
-		lda szam,x
        	pha
                dex
                bpl -

                jsr chs2lba
                lda szam+3
                and #$0f
                pha

                ldx #2
-		lda szam,x
                pha
                dex
                bpl -

		lda partition_currentp_exp
                ora #3
                tax

		ldy #3
                sec
-		pla
                sbc partition_fat_data_exp,x
                sta next_sector,y
                dex
		dey
                bpl -
                php

		inx
                lda partition_fat_sectperclust_exp,x
-		lsr
                beq +
                lsr next_sector
                ror next_sector+1
                ror next_sector+2
                ror next_sector+3
                #jmps -
+
		plp
		ldx #0
                ldy #5
-		pla
        	sta szam,x
                inx
                dey
                bne -
		rts
                .pend

XIT_nextcluster	.proc
		lda partition_currentp_exp
                ora #3
                tax
                lda partition_fat_type_exp-3,x
                beq fat32
                cmp #1
                beq fat16
                gne fat12

fat32           asl next_sector+3       ;fat32
		rol next_sector+2
		rol next_sector+1
		rol next_sector

                lda next_sector+3
                pha

                clc
                clv
                jsr readfatx

                pla
                asl
                tax

                ldy #3
-		jsr getfat
                sta next_sector,y
                inx
                dey
                bpl -
                and #$0f
                sta next_sector
                rts

fat16   	lda next_sector+3
		pha
		lda next_sector+2	;fat16

                clc
                jsr readfatx2

		pla
                asl
                tax

		jsr getfat
		sta next_sector+3
		inx
		jsr getfat
		sta next_sector+2
		rts

fat12	  	lda next_sector+2	;fat12
                lsr
		tay
		lda next_sector+3
                ror
                php

		clc
                adc next_sector+3
                pha
                tya
                adc next_sector+2
                ror
                php

                clc
                pha
                jsr readfatx2
                #ply_a

                plp
                #plx_a

		jsr getfat
		sta next_sector+3

                inx
                bne nni
                bcc nni2

		sec
		jsr readfatx3

                ldx #0
                clc
                .byte SKIP1BCS
nni2		sec

nni             jsr getfat

                plp
                bcs +
                and #$0f
                gcc nnk
+
		ldx #4
-		lsr a
                ror next_sector+3
                dex
                bne -
nnk		sta next_sector+2
		rts

getfat		lda ram_fat_exp,x
		bcc set_v
                lda ram_fat_exp+$100,x
set_v		rts

readfatx2       tay
readfatx3      	#sev set_v
readfatx
		ldx #end_zeropage-start_zeropage
-		lda start_zeropage-1,x
        	pha
                dex
                bne -
                bvc +
                stx next_sector
                stx next_sector+1
                sty next_sector+2
+
		lda partition_currentp_exp
                ora #3
                tax
		ldy #3
-		tya
		beq +
		lda next_sector-1,y
+		adc partition_fat_fat_exp,x
                sta next_sector,y
                dex
                dey
                bpl -

                ldx #3
-               iny
		lda next_sector,x
		sta szam,y
                dex
                bpl -

		jsr fatlba2chs

		lda #ram_exp_fat
                jsr XIT_read_a_sector

		ldx #0
-		pla
        	sta start_zeropage,x
                inx
                cpx #end_zeropage-start_zeropage
                bne -
rrts		rts
		.pend

fatlba2chs     	.pend
		#ldx_l_a current_drive_exp
		lda drive_lba_exp,x
                #orasta_a szam+3
                jmp lba2chs
		.pend

detectfat       .proc
sectperclust	= pom4
datastart	= pom9
rootdir		= pom5

		lda #>boot_sector_fat_sign_exp
		jsr check_s
                bne XIT_nextcluster.rrts

                lda boot_sector_fat_bytepersec_exp+1
                eor #2
                ora boot_sector_fat_bytepersec_exp
		bne XIT_nextcluster.rrts

                ldx #<boot_sector_fat_reserved_exp
                jsr breadword0
                lda boot_sector_fat_secperclust_exp
                sta sectperclust

                lda #3
                tay
		ora partition_offset_exp
                tax

                clc
-		lda datastart,y
                adc next_sector,y
                sta partition_fat_fat_exp,x
                sta rootdir,y
                dex
                dey
                bpl -

                ldx #<boot_sector_fat_fatsectors_exp
                jsr breadword0
                php
                bne lel2x

                ldx #<boot_sector_fat_fat2sectors_exp
                jsr bcopydword

lel2x           ldx #3
                clc
-		lda rootdir,x
                adc next_sector,x
                sta rootdir,x
                dex
                bpl -
		#dec_l_a boot_sector_fat_numfat_exp
                bne lel2x

                ldx #<boot_sector_fat_rootcount_exp
                jsr breadword0

                ldx #4
-		lsr next_sector+2
                ror next_sector+3
                dex
                bne -

		ldx #4
                clc
-		lda next_sector-1,x
                adc rootdir-1,x
                sta datastart-1,x
                lda boot_sector_fat_rootclust_exp-1,x
                sta szam-1,x
                dex
                bne -

		plp
                beq foundfat		;fat32

		ldx #<boot_sector_fat_totalsect_exp
		jsr breadword0
                bne rdr
                ldx #<boot_sector_fat_totalsect2_exp
                jsr bcopydword
rdr
                ldx #3
                sec
-		lda next_sector,x
                sbc datastart,x
                sta next_sector,x
                dex
                bpl -

		lda sectperclust
cc              lsr
                beq tpi
	      	lsr next_sector
	      	ror next_sector+1
	      	ror next_sector+2
	      	ror next_sector+3
                #jmps cc

const4085	.byte 0,0,>4085,<4085

tpi		ldx #4
-	      	lda next_sector-1,x
                sbc const4085-1,x
                #stz_a szam-1,x
                dex
                bne -
                inx
                stx szam		;fat16
                bcs foundfat
                inx                     ;fat12

foundfat	#phx_a

		ldy #2
lel6            lda sectperclust
                eor #$ff
                ldx #3
                sec
                .byte SKIP2
lel5		lda #$ff
		adc datastart,x
                sta datastart,x
                dex
                bpl lel5
                dey
                bne lel6

                lda #%10000000		;valid, readonly
                jsr szam_rootworkbig
                lda sectperclust
                sta partition_fat_sectperclust_exp-3,x
                lda boot_sector_fat_rootcount_exp
                sta partition_fat_rootsect_exp-3,x
                lda boot_sector_fat_rootcount_exp+1
                sta partition_fat_rootsect_exp-2,x
		pla
                sta partition_fat_type_exp-3,x

                ldy #3
-		lda datastart,y
                sta partition_fat_data_exp,x
                lda rootdir,y
                sta partition_fat_root_dir_exp,x
                dex
                dey
                bpl -

		txa
		clc
                adc #5
                sta partition_offset_exp
                and #31
                rts

breadword0	clc
bcopydword      ldy #3
jc		lda boot_sector_fat_exp,x
                sta next_sector,y
                tya
                eor #2
                beq jf
jf2             inx
                dey
                bpl jc
                rts

jf		bcs jf2
		sec
		sta next_sector
		sta next_sector+1
		lda next_sector+2
		ora next_sector+3
		rts
                .pend
