;
; function.asm - Function key handler
;
; Written by
;  Kajtar Zsolt <soci@c64.rulez.org>
;
;    This file is part of IDEDOS the IDE64 disk operating system
;    See README for copyright notice.
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
		#assert_cfg_open

functionkeys	.proc
                lda $d3		;X
                sta $ca
                lda $d6		;Y
                sta $c9
                #phy_a
                #phx_a
                lda $d0
                beq ss
                #psr $e63a
                #assert_a000romioonly
exit            jmp exit2basic

		.assert CFG_RAM | CFG_A000_ROM | CFG_D000_IO | CFG_E000_ROM, CFG_RAM | CFG_A000_ROM | CFG_D000_IO | CFG_E000_ROM, CFG_OPEN_RAM | CFG_A000_RAM | CFG_A000_BASIC | CFG_D000_ROM | CFG_E000_OPEN
ll              jsr $e716

		.assert CFG_8000_ROM | CFG_A000_ROM | CFG_D000_IO, CFG_8000_ROM | CFG_A000_ROM | CFG_D000_IO, CFG_8000_RAM | CFG_A000_RAM | CFG_A000_BASIC | CFG_D000_ROM
ss		lda $c6
		bne kfk
                sta $cc
                ldx #5
-               lda keywait,x
                sta $267,x
                lda ps,x
                pha
                dex
                bpl -
                gmi exit

loadrun         ldx #9
                stx $c6
-               lda loadtxt-1,x
                sta $277-1,x
                dex
                bne -

kfk		sta $cc
                sta $0292
                sei
                #sta_cfg_16
                lda $cf
                beq kk
                #stz_a $cf
                lda $ce
                ldx $0287
                jsr $ea13
kk              jsr $e5b4
                cmp #$83
                beq loadrun

		ldx $d4    	;Quote mode
                bne jdx
                ldx $d8		;Insert mode
jdx             bne jd
                bit msgmode    	;Program mode
                bpl jd

                cmp #4
                bne noctrld
                lda #24
                sta ActualFilename
re              dec ActualFilename
		beq nincs
		#lda0
                sta ActualFNLength
                sec
                adc ActualDev
                cmp #31
                bcs vv
                cmp #8
                bcs +
vv              lda #8
+               sta ActualDev
                lda #$60
                sta ActualSecAddr
                sta ActualLogical
                jsr newopen_t
                #assert_cfg_16
                lda #$60
                jsr newclose_t
                bit Status
                bmi re
                ldx #$ff
                lda ActualDev
                sec
id              inx
                sbc #10
                bcs id
                adc #$3a
                pha
                txa
                beq kfs
                ora #$30
                jsr $e716
kfs             pla
                jsr $e716
nincs           lda #13
llx             gne ll

noctrld		pha
		sec
		sbc #$85
                cmp #8
                tay
                pla
		bcs jd

uru             #sta_cfg_open
		lda function_keys_exp,x
                #sta_cfg_16
                beq kf
		cmp #13
                beq kf
                cpy #0
                bne kf2
                jsr $e716
                iny
kf              dey
		bmi jd
kf2		inx
                bpl uru

jd              tay
                beq ss
		cmp #13
		bne llx
                #psr $e602
		gcs exit

                #assert_a000romonly
ps              .rta $267
		#assert_cfg_open
                .rta switch_16k
                .rta kfk

                #assert_a000romonly

loadtxt		.text "load",13,"run",13

keywait		lda $c6
		beq keywait
                rts
                .pend
