;
; man_fastload.asm - disk speeder routines
;
; Written by
;  Kajtar Zsolt <soci@c64.rulez.org>
;
;    This file is part of IDEDOS the IDE64 disk operating system
;    See README for copyright notice.
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
		.assert CFG_8000_ROM | CFG_A000_ROM | CFG_D000_IO, CFG_8000_ROM | CFG_A000_ROM | CFG_D000_IO, CFG_8000_RAM | CFG_A000_RAM | CFG_A000_BASIC | CFG_D000_ROM

man_fastload_init_ .proc
                #sta_cfg_open
		jsr OP_save_zeropage
                #sta_cfg_16

                lsr next_sector

                jsr ee
                bne ajj
                jsr ee
                bne ajj

		ldx selectedwin+1
                jsr man_drivenum
                #assert_cfg_16

		.if (JIFFYDOS_ACCEL=0) & (SUPERCPU=0)
                #sta_cfg_open
                lda JiffyDos_present_exp
                #sta_cfg_16
                beq wr
                .fi

		bit Jiffyflag
                .if SUPERCPU=1
                bpl wr
                bvs wr
                .else
		bvc wr
                .fi
		jsr iecuntalk

		tya
		jsr iectalk
		lda #$61
		jsr iectksa
                .if (SUPERCPU=1) | (JIFFYDOS_ACCEL=0)
                sec
                ror next_sector
                .else
		asl Jiffyflag  		;fastload!
                .fi
                #jmps uk

wr
		.if DOLPHINDOS_ACCEL=1
                ldx $dc0c		;eecd
                bpl nodolp
                jsr dolphin_fastload_init
        	bne jooo
nodolp
		.fi
		jsr newclrchn_t
		jsr fastloadinit

uk

                lda next_sector
                .if (JIFFYDOS_ACCEL=1) & (SUPERCPU=0)
		ora Jiffyflag
                .fi
                and #$80
                .byte SKIP2
jooo		lda #$80
                sta man_fast
ajj
		.if SUPERCPU=1
                jmp OP_restore_zeropage
                .else
                sta cfg_open
                #assert_cfg_open
		jsr OP_restore_zeropage
                sta cfg_16
                #assert_cfg_16
                rts
                .fi

ee              jsr iecin
                ldy man_offs
                sta (m_p1),y
                inc man_offs
                lda Status
		rts
                .pend
;--------------------------
                #assert_cfg_16
man_fastload_	.proc
		sei
                .if DOLPHINDOS_ACCEL=1
                ldx $dc0c		;eecd
                bpl nodolp2

		ldx #$10
                lda man_fast
                lsr
                ldy #0
                bcs ef07
                inc man_fast
                ldy #2

		txa
ff3d    	bit $dd0d
        	bne ff47
        	bit $dd00
        	bpl ff3d
ff47            sta $dd01

eefa            bit $dd00
                bvs ef49
                bit $dd0d
                beq eefa
                lda $dd01

ef07            txa
ef12            bit $dd00
                bvs ef49
                bit $dd0d
                beq ef12
                lda $dd01
                sta (m_p1),y
                iny
                bne ef07
		inc m_p1+1
                lda m_p1+1
                and #$1f
		bne ef07
                geq eee

ef49            jsr $ee97		;datahi
                txa
ef4f            bit $dd0d
                bne ef5e
                inx
                bne ef4f
                lda #$42
                .byte SKIP2
ef5e            lda #$40
		jsr f958
eee		sta Status
		cli
                rts
nodolp2
		.fi

		.if SUPERCPU=1
                sta scpu_system_1mhz_start
                .fi
		lda $dd00
		and #7
		sta Status
		ora #$20
		tax

                lda man_fast
                lsr
                ldy #0
                bcs mmc
                inc man_fast
                ldy #2
		gne tkm

nw
tkm
		lda Status
		sta $dd00
-		bit $dd00
		bvc -
		bpl msc
		ldx #$64
kkw		bit $dd00
		bvc eof
		dex
		bne kkw
		lda #$42
		.byte SKIP2
eof		lda #$40
		sta Status
		ldx #10
-               dex
                bne -
		.if SUPERCPU=1
                sta scpu_system_1mhz_exit
                .fi
                cli
                rts				;exit

msc		bit $dd00
		bpl msc

mmc
mjj		sec
mc		lda $d012
		sbc #$32
		bcc mcx
		and #7
		beq mc
mcx		lda Status
		stx $dd00
		bit $dd00
		bvc nw
		nop
		sta $dd00
		ora $dd00
		lsr
		lsr
		nop
		ora $dd00
		lsr
		lsr
		eor Status
		eor $dd00
		lsr
		lsr
		eor Status
		eor $dd00
		nop
		nop
		sta (m_p1),y
		iny
		bne mjj
		inc m_p1+1
                lda m_p1+1
                and #$1f
		bne mmc
                sta Status
		.if SUPERCPU=1
                sta scpu_system_1mhz_exit
                .fi
                cli
                rts

		.pend
;-----------------------------------
man_fastsave_init_ .proc
                #sta_cfg_open
		jsr OP_save_zeropage
                #sta_cfg_16

                lsr next_sector

		ldx selectedwin
                jsr man_drivenum
                #assert_cfg_16

		.if DOLPHINDOS_ACCEL=1
                ldx $dc0c		;eecd
                bpl nodolp
                lda #$5a
                jsr dolphin_init
                jsr $ee8e
                jsr efef
        	bne jooo
nodolp
		.fi
		jsr newclrchn_t
		jsr fastsaveinit

                lda next_sector
                and #$80
                .byte SKIP2
jooo		lda #$80
                sta man_fast2

		.if SUPERCPU=1
                jmp OP_restore_zeropage
                .else
                sta cfg_open
                #assert_cfg_open
		jsr OP_restore_zeropage
                sta cfg_16
                #assert_cfg_16
                rts
                .fi

                .pend
;-----------------------------------
                #assert_cfg_16
man_fastsave_	.proc
		sei
                .if DOLPHINDOS_ACCEL=1
                ldx $dc0c		;eecd
                bpl nodolp2

                inc m_ascii
                bne koe2
                inc m_ascii+1
koe2
                ldy #0
ff47            lda (m_p1),y
                iny
                bne ti
                inc m_p1+1
ti		inc m_ascii
                bne koe
                inc m_ascii+1
                beq en
koe             sta $dd01
                lda #$10
ff3d    	bit $dd0d
                bne ff47
                bit $dd00
                bpl ff3d
en
                pha
                tsx
                #sbx_a 256-6
                lda $100,x
                clc
		beq eee
		jsr $ee85		;clkhi
                sec
eee             pla
                sta $dd01

                lda #$10
ff3d_           bit $dd0d
                bne ff47j
                bit $dd00
                bpl ff3d_
ff47j
		bcc jop
                jsr f958
jop		cli
                rts

nodolp2
                .fi

		.if SUPERCPU=1
                sta scpu_system_1mhz_start
                .fi
		sec

tu      	lda #254
                sta $98
		adc m_ascii
                sta m_ascii
                #lda0
                adc m_ascii+1
                sta m_ascii+1
                bcc ko

                tsx
                #sbx_a 256-5
                lda $100,x
		beq ko

                lda m_ascii
                eor #255
                sta $98
                dec $98
                .byte SKIPLDA0
ko              #lda0
                jsr sendbyte
                ldy #0
nx              lda (m_p1),y
                jsr sendbyte
                bcc nx
                lda m_ascii+1
                beq end
                tya
                clc
                adc m_p1
                sta m_p1
                bcc tu
                clc
                inc m_p1+1
                gne tu

end
		.if SUPERCPU=1
                sta scpu_system_1mhz_exit
                .fi
		cli
		rts

;-------------------------------------

sendbyte        pha
                lsr
                lsr
                lsr
                lsr
                tax
                sec
-               bit $dd00
                bvc -
                .page
iw              lda $d012
		sbc #$32
                bcc kk
                and #$07
                beq iw
kk
		.endp
		lda #$07
                sta $dd00
                lda tr,x
                nop
                nop
                sta $dd00
                lsr
                lsr
                and #$f7
                sta $dd00
                pla
                and #$0f
                tax
                lda tr,x
                sta $dd00
                lsr
                lsr
                and #$f7
                sta $dd00
                lda #$27
                iny
                cpy $98
                sta $dd00
                rts

 		.page
tr              .byte $07,$87,$27,$a7,$47,$c7,$67,$e7
                .byte $17,$97,$37,$b7,$57,$d7,$77,$f7
                .endp

		.pend

		.if SUPERCPU=1
man_drivenum	.proc
                lda man_drive,x
                jmp set_current_drive_from_drive_number
		.pend
                .else
man_drivenum	.proc
                sta cfg_open
                #assert_cfg_open
		lda man_drive,x
                jsr set_current_drive_from_drive_number
                sta cfg_16
                #assert_cfg_16
                rts
                .pend
                .fi
