;
; man_hi.asm - File manager upper half
;
; Written by
;  Kajtar Zsolt <soci@c64.rulez.org>
;
;    This file is part of IDEDOS the IDE64 disk operating system
;    See README for copyright notice.
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
;---------------------------
;ONLY THOSE MANAGER ROUTINES ARE HERE THAT HAVE TO USE MEMORY AT $8000-$9FFF!
;---------------------------
; Print directory into panel
;
		#assert_cfg_16

printdirandstat	jsr man_printstat
printdir	.proc
		sei
		ldx #<$450
		lda #>$450
		ldy selectedwin
		beq +
		ldx #<$630
		lda #>$630
+
		stx m_p2
		stx m_p3
		sta m_p2+1
		eor #$d8^$04
		sta m_p3+1

		lda man_el_l,y
		sta m_p5
		lda man_el_h,y
		sta m_p5+1

		lda #11
		sta m_p4

		dec $01

lop		ldy selectedwin
		lda m_p5
		cmp man_files_l,y
		lda m_p5+1
		sbc man_files_h,y
		bcc uii

		lda #32
		ldy #27
-		sta (m_p2),y
		dey
		bpl -
		lda m_p2
		adc #40-1
		#jmps ide

uii		ldy m_p5
		lda m_p5+1
		lsr
		jsr calc_filepos.in

		ldy #26
		lda (m_p1),y
		bmi sel			;selected?
		dey
		lda (m_p1),y
sel		ldy #27
-		sta (m_p3),y
		dey
		bpl -
		inc m_p5
		bne +
		inc m_p5+1
+
		iny
		#ldatax (m_p1),y
		iny
		lda (m_p1),y
		inc $01
		jsr numtoasc16
		dec $01
		lda #32
-		cpy #5
		bcs +
		sta (m_p2),y
		iny
		gcc -
+
		lda #2
                tay
		adc m_p2
		sta m_p2
		bcc +
		inc m_p2+1
+
-		#ldatax (m_p1),y
		lda cconv,x
		sta (m_p2),y
		iny
		cpy #25
		bcc -

		lda m_p2
		adc #40-3-1
ide		sta m_p2
		sta m_p3
                bcc cs
		inc m_p2+1
		inc m_p3+1

cs		dec m_p4
		bne lop

		inc $01
		cli
		rts
		.pend
;---------------------------
; Load directory from drive
;
mloaddir	.proc
             	dec $01
		lda Status
		eor #$40
		bne gondvan
		bcc noerror

gondvan    	lda #32
                tay
l		dey
		sta (m_p2),y		;erase disklabel
		bne l
                ldx selectedwin
		tya
		sta man_files_l,x
		sta man_files_h,x
		sta man_fulllo,x
		sta man_fullhi,x
		sta man_fullfree,x
		sta man_partition,x
                .if SUPERCPU=1
                inc a
                .else
                lda #1
                .fi
                sta man_parlist,x	;not in partition dir
		sec
		gcs null

noerror		#phx_a
		ldx selectedwin
                tya
;                clc
		sbc dirm,x
		sta m_p3
                sta man_dirend,x
                cmp #$3f
                bcc mv
                bne nc
                pla
                cmp #$df
                bcc mv2
		.byte SKIP1BCC
nc		pla
		inc $01
		jsr savedrawwin
                .word $05bc
		.byte 18,4
		.word manager.txttoomany

		cli
		jsr waitkey_restorewin
                sei
                dec $01

                ldx selectedwin
                lda #$3f
                sta m_p3
                sta man_dirend,x
                lda #$df
                .byte SKIP1BEQ
mv		pla
mv2
                ldy #5
-		lsr m_p3
		ror
                dey
                bne -
		sty m_p2
		sty m_p4

		sta man_files_l,x
		eor #255
		clc
		adc #1
		sta m_p5
		lda m_p3
		sta man_files_h,x
		eor #255
		adc #0
		sta m_p5+1
                lda dirm,x
                sta m_p2+1

		ldy selectedwin
                lda man_virtual,x
                bne +
		ldy #$e2
		lda (m_p2),y
		sta man_partition,x
+		inc m_p2+1


                .if <man_sort1_l
		lda #<man_sort1_l
		sta m_p3
		sta m_p1
                .else
                #stz_a m_p3
                #stz_aa m_p1
                .fi
		ldy sortm,x
		sty m_p3+1
		iny
		iny
		sty m_p1+1

		ldy man_floppy,x
		bne flo
                lda man_parlist,x
                eor #1
                bne flo
		lda #<man_pontpont
		sta (m_p3),y
		lda #>man_pontpont
		sta (m_p1),y
		inc m_p3
		inc m_p1
		inc man_files_l,x
		bne flo
		inc man_files_h,x

flo		bcs null2		;empty dir

p		ldy #0
                #ldatax (m_p2),y
		iny
		lda (m_p2),y
		pha			;copy filesize
                lda #'"'
	      	iny
ll		cmp (m_p2),y
		beq mc
                inc m_p2
		bne ll

mc              ldy #0
		lda m_p2
                sta (m_p3),y
		lda m_p2+1
                sta (m_p1),y
                txa
                sta (m_p2),y
                iny
                pla
                sta (m_p2),y
                iny
                lda #'"'
-		iny          		;012345678901234567890123456
		cmp (m_p2),y 		;xx"1234567890123456"*PRG<AB
		bne -
                #lda0
                sta (m_p2),y

                ldy #21
-		lda (m_p2),y
                cmp dirtxt-21,y
		bne nd
		iny
                cpy #24
                bcc -

		ldy #3
		lda (m_p2),y
		cmp #"."
		bne nemp
		iny
		lda (m_p2),y
		beq rh			;"." found
		iny
		eor #"."
		ora (m_p2),y		;".." found
		bne nemp
rh		ldx selectedwin
		lda man_files_l,x
		bne h
		dec man_files_h,x	;".." and "." not counts...
h		dec man_files_l,x
		#jmps id

nemp		ldx #0
		.byte SKIP2
nd		ldx #1

		lda manager_dircolor,x
		ldy #25
		sta (m_p2),y

		lda manager_seldircolor,x
		iny
		sta (m_p2),y

                inc m_p3
                inc m_p1
                bne id
                inc m_p3+1
                inc m_p1+1

id		lda m_p4
		clc
		adc #32
		sta m_p4
		sta m_p2
		bcc +
		inc m_p2+1
+
		inc m_p5
		bne +
		inc m_p5+1
+		bne p

null2		ldx selectedwin	;end of dir reached
		ldy #0
		lda (m_p2),y
		sta man_fulllo,x
		iny
		lda (m_p2),y
		sta man_fullhi,x
		ldy #9
		lda (m_p2),y
		sta man_fullfree,x

		clc
null
                .if SUPERCPU=0
		ldy #31
-		lda pontpont,y
		sta man_pontpont,y
		dey
		bpl -

		lda manager_dircolor
		sta man_pontpont+25
		sta man_pontpont+26

		inc $01

zeroblockfilesel .proc
                #stz_a man_block_l,x
		#stz_aa man_block_m,x
		#stz_aa man_block_h,x
		#stz_aa man_filessel_l,x
		#stz_aa man_filessel_h,x
                rts
                .pend

pontpont	.word 0
		.text '"',".",".",0,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32
dirtxt          .text "dir<",32,32,32,0,1,1
                .else
                inc $01
                jmp mloaddir2

dirtxt          .text "dir"
		.pend
                .fi
;---------------------------
; Get filetype into A,X,Y
;
man_ext		.proc
		dec $01
		ldy #21
		lda (m_p1),y
		pha
		iny
		#ldatax (m_p1),y
		iny
		lda (m_p1),y
		tay
		pla
		inc $01
rt		rts
		.pend
;---------------------------
; Get selection
;
man_dir		#lda0
		ldy #25
                .byte SKIP2
man_sel		.proc
		ldy #26
man_get		.proc
		dec $01
		eor (m_p1),y
		php
		inc $01
		plp
		rts
		.pend
;---------------------------
; Copy filename to $201 like "sdfsdf,prg"
;
man_copyfname	.proc
		ldx #0
		clc
                .byte SKIP1BCS
man_copyfname3	.proc
		sec
		dec $01
		ldy #3
ry		lda (m_p1),y
		beq iu
                .byte SKIP2
or		lda #"?"
		sta $201,x
                eor #","
                beq or
		inx
		iny
		bpl ry
iu		bcs wx
		lda #","
		sta $201,x
		inx
		ldy #21
xp		lda (m_p1),y
		cmp #32
		beq wx
                cmp #"<"
                beq wx
		sta $201,x
		inx
		iny
		cpy #24
		bne xp
wx
		stx $200
                #lda0
                sta $201,x
		inc $01
		#jmps setname200
		.pend
;---------------------------
; Toggle selection
;
man_toggle_sel	.proc
		lda m_p1+1
		cmp #>man_dirmem1
		bcc tu
		dec $01
		ldy #26
		lda (m_p1),y
                cmp #$80
		eor #128
		sta (m_p1),y
		ldx selectedwin
		ldy #0
		lda man_block_l,x
		bcc nc
		sbc (m_p1),y
		sta man_block_l,x
		lda man_filessel_l,x
		bne hp
		dec man_filessel_h,x
hp		dec man_filessel_l,x
		iny
		lda man_block_m,x
		sbc (m_p1),y
		bcs nc2
		dec man_block_h,x
		gcc nc2

nc		inc man_filessel_l,x
		bne hp2
		inc man_filessel_h,x
hp2		adc (m_p1),y
		sta man_block_l,x
		iny
		lda man_block_m,x
		adc (m_p1),y
		bcc nc2
		inc man_block_h,x
nc2		sta man_block_m,x
		inc $01
tu		rts
		.pend
;---------------------------
; Quicksort directory list (if not on floppy)
;
sortdir		.proc
i_h     	= m_ascii+1
j_h     	= m_ascii+2
l		= m_ascii+3
r		= m_p4
i_l	   	= m_p3
j_l     	= m_p5

		ldx selectedwin

		lda man_files_l,x
		ora man_files_h,x
		beq err

		lda man_parlist,x	;no sorting for partition list
                lsr
                ora man_floppy,x	;or floppy
                ora man_virtual,x      	;or virtual
                bne err

		ldy #1
		sty l
		sty i_l
		sty l+1
		sty i_h

		lda sortm,x
                sta m_ascii

		lda man_files_l,x
		sec
		sbc #1
		sta r
		sta j_l
		lda man_files_h,x
		sbc #255
		sta r+1
		sta j_h

		lda l
		cmp r
		lda l+1
		sbc r+1
		bge err
		dec $01
		lda r		;j=r
		jsr quicksort
		inc $01
err     	rts

quicksort2      sty i_l
                .if SUPERCPU=1
		ldx l+1
                .fi
                stx i_h
                lda j_h
                sta r+1
		lda j_l
                sta r
quicksort	clc
		adc l
                tax
		lda r+1
		adc l+1
		ror
		tay
                txa
		ror
		cpy #2
		jsr calc_filepos	;buf1=xx[(l+r)/2]
		sta m_p2+1
		lda m_p1
		sta m_p2

repeat
lp1x    	ldx i_h
lp1		ldy i_l
		cpx #2
		jsr calc_filepos.in

		ldy #25
		lda (m_p1),y
		bpl e11

		lda (m_p2),y
		bpl nn1n
		gmi ee1

e11		lda (m_p2),y
		bmi i1

ee1		ldy #2
l1q     	iny
		lda (m_p2),y
		beq i1
		cmp (m_p1),y
		beq l1q

nn1		bcc i1

nn1n		inc i_l
		bne lp1
		inc i_h
		gne lp1x
i1

                ldx j_h
lp2		ldy j_l
		cpx #2
		jsr calc_filepos.in

		ldy #25
		lda (m_p2),y
		bpl e22

		lda (m_p1),y
		bpl nn2n
		gmi ee2

e22		lda (m_p1),y
		bmi i2

ee2		ldy #2
l2q		iny
		lda (m_p1),y
		beq i2
		cmp (m_p2),y
                beq l2q

nn2		bcc i2

nn2n		lda j_l
		bne rp
                dex
		stx j_h
rp		dec j_l
		#jmps lp2

i2
		ldy j_l		;if (i<=j)
		cpy i_l
                txa
                sbc i_h
		blt th

		lda i_h
                #andlsr 2
		adc m_ascii
		sta m_p3+1

		txa
                #andlsr 2
		adc m_ascii
		sta m_p5+1

		tya
		bne rr2
		dec j_h
rr2
                .if SUPERCPU=1
                lda (m_p3)
                xba
                lda (m_p5)
                sta (m_p3)
                xba
                sta (m_p5)

                lda m_p3+1
                adc #2
                sta m_p3+1
                lda m_p5+1
                adc #2
		sta m_p5+1

                lda (m_p3)
                xba
                lda (m_p5)
                sta (m_p3)
                xba
                sta (m_p5)
                .else
		ldy #0

                lax (m_p3),y
                lda (m_p5),y
                sta (m_p3),y
                txa
                sta (m_p5),y

                lda m_p3+1
                adc #2
                sta m_p3+1
                lda m_p5+1
                adc #2
		sta m_p5+1

		lax (m_p3),y
		lda (m_p5),y
		sta (m_p3),y
                txa
		sta (m_p5),y
                .fi

		dec j_l

		inc i_l
		bne rr
		inc i_h
rr
		lda j_l		;if (i<=j)
		cmp i_l
		lda j_h
		sbc i_h
	     	bge repeat
th
		ldy l
		cpy j_l
                .if SUPERCPU=1
		lda l+1
                .else
		lax l+1
                .fi
		sbc j_h
		bge n1

		lda i_l
		cmp r
		lda i_h
		sbc r+1
		bge quicksort2

                lda r
                pha
                lda r+1
                pha
		lda i_l
                pha
                lda i_h
                pha
                jsr quicksort2
                pla
                sta i_h
                sta l+1
                pla
                sta i_l
                sta l
                pla
                sta r+1
                sta j_h
		pla
                sta r
                sta j_l
                jmp quicksort
n1
		ldy i_l
		cpy r
                .if SUPERCPU=1
		lda i_h
                .else
		lax i_h
                .fi
		sbc r+1
		bge n2

		sty l
                .if SUPERCPU=1
		ldx i_h
                .fi
		stx l+1
		lda r+1
		sta j_h
		lda r
		sta j_l
		jmp quicksort
n2
		rts

		.pend
;---------------------------
; Calc the memory location of file under the cursor
;
calc_filepos_cursor .proc
		ldx selectedwin
		lda man_el_l,x
		clc
		adc man_bar,x
		bcs calc_filepos
		ldy man_el_h,x
		cpy #1
;---------------------------
; Calc the memory location of file
;
; High byte in A! (quicksort)
;
calc_filepos	.proc
		tay
in		lda selectedwin
		bcc e
		bne ee1

		lda man_sort1_l+256,y
		sta m_p1
		lda man_sort1_h+256,y
		sta m_p1+1
		rts

ee1		lda man_sort2_l+256,y
		sta m_p1
		lda man_sort2_h+256,y
		sta m_p1+1
		rts

e		bne ee2

		lda man_sort1_l,y
		sta m_p1
		lda man_sort1_h,y
		sta m_p1+1
		rts

ee2		lda man_sort2_l,y
		sta m_p1
		lda man_sort2_h,y
		sta m_p1+1
		rts
		.pend
;---------------------------
; Copy upper part
;
copy_upper	.proc
		dec $01
nvx2            inc m_ascii
		beq v1
vm		lda (m_p1),y
		jsr newchrout_t
                lda Status
                bne kb2
                iny
                bne nvx2
                inc $01
                jsr man_showbar1
                dec $01
                inc m_p1+1
                gne nvx2

v1              inc m_ascii+1
		bne vm
kb2		inc $01
		rts
                .pend
;---------------------------
; Copy panel information
;
man_copypanel	.proc
		dec $01
                ldx selectedwin+1
                lda dirm,x
                sta m_p1+1
                lda dirm+1,x
                sta m_p2+1
                sta m_p3+1

                lda man_dirend,x
                pha
                tax
                lda #$e0
                jsr copy

                ldx selectedwin
                lda sortm+1,x
                sta m_p1+1
                lda sortm,x
                sta m_p2+1
                .if <man_sort1_l
                lda #<man_sort1_l
                .else
                #lda0
                .fi
                ldx #1
                jsr copy
                ldy #0
                ldx #1
ndv             lda (m_p1),y
                cmp #$20
                bcc vb2
                cmp #$60
                bcs vb
                adc #$81
vb              sbc #$40
vb2             sta (m_p2),y
                iny
                bne ndv
                inc m_p1+1
                inc m_p2+1
                dex
                bpl ndv

                #stz_aa m_p3
		inc m_p3+1
                #plx_a
                ldy #26
ksd2            clc
-		lda (m_p3),y
                and #$7f
                sta (m_p3),y
                tya
                adc #32
                tay
                bcc -
                inc m_p3+1
                dex
                bpl ksd2
                inc $01
                rts

copy            ldy #0
                sta m_p1
                sta m_p2
-		lda (m_p1),y
                sta (m_p2),y
                iny
                bne -
                inc m_p1+1
                inc m_p2+1
                dex
                bpl -
		rts
		.pend

sortm		.byte >man_sort1_l
		.byte >man_sort2_l
                .byte >man_sort1_l

dirm		.byte >(man_dirmem1-$e0)
		.byte >(man_dirmem2-$e0)
		.byte >(man_dirmem1-$e0)

