/*

 chksum.c - checksum calculator

 Written by
  Kajtar Zsolt <soci@c64.rulez.org>

    This file is part of IDEDOS the IDE64 disk operating system
    See README for copyright notice.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include <stdio.h>

int main(int argc, char *argv[]) {
    FILE *f;
    unsigned char mem[65536];
    unsigned int sum=0;
    int i;
    
    f=fopen("bank0.o64","rb");
    fread(&mem[0x0000],16384,1,f);
    fclose(f);

    f=fopen("bank1.o64","rb");
    fread(&mem[0x4000],16384,1,f);
    fclose(f);

    f=fopen("bank2.o64","rb");
    fread(&mem[0x8000],16384,1,f);
    fclose(f);

    f=fopen("bank3.o64","rb");
    fread(&mem[0xc000],16384,1,f);
    fclose(f);
    
    for (i=0;i<65536;i++) sum+=mem[i];
    
    mem[0x51]=sum & 0xff;
    mem[0x52]=(sum >> 8) & 0xff;

    f=fopen(argv[1],"wb");
    fwrite(mem,65536,1,f);
    fclose(f);
    
    return 0;
}
