;
; ram.asm - zeropage related
;
; Written by
;  Kajtar Zsolt <soci@c64.rulez.org>
;
;    This file is part of IDEDOS the IDE64 disk operating system
;    See README for copyright notice.
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
		#assert_cfg_open
;----------------------------------
;Restore zeropage
;
OP_restore_zeropage_scpu01down .proc
		#OP_scpu01down
OP_restore_zeropage .proc
		ldx #(end_zeropage-start_zeropage)/2
-		lda zp_exp-1,x
		sta start_zeropage-1,x
		lda zp_exp-1+(end_zeropage-start_zeropage)/2,x
		sta start_zeropage-1+(end_zeropage-start_zeropage)/2,x
		dex
		bne -
		.pend
;----------------------------------
;Handle zeropage bug
;

zp_bug		.proc
                .if DEBUG
                txa
                eor zp_valid_exp
                bne +
		brk
+
		.fi
                #stx_l_a zp_valid_exp
                rts
		.pend
;----------------------------------
;Save zeropage
;
		.cerror (end_zeropage-start_zeropage) & 1;zeropagesize!

OP_save_zeropage_scpu01up .proc
		#OP_scpu01up
OP_save_zeropage .proc
		ldx #(end_zeropage-start_zeropage)/2-1
-		lda start_zeropage,x
		sta zp_exp,x
		lda start_zeropage+(end_zeropage-start_zeropage)/2,x
		sta zp_exp+(end_zeropage-start_zeropage)/2,x
		dex
		bpl -
                gmi zp_bug
		.pend

