;
; selftest.asm - Selftesting
;
; Written by
;  Kajtar Zsolt <soci@c64.rulez.org>
;
;    This file is part of IDEDOS the IDE64 disk operating system
;    See README for copyright notice.
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
		#assert_8000romioonly
                .cpu 6502

selftest	.proc
		sta cfg_8
                #assert_cfg_8

                sta scpu_hwenable
                sta scpu_nooptim
                sta scpu_hwdisable

		ldx #0
		stx $dd02
		stx $d015
		stx $d418
-		lda #32
		sta $400,x
		sta $500,x
                sta $600,x
                sta $700,x
		lda #1
		sta $d800,x
		sta $d900,x
		inx
		bne -

		lda #6
		sta $d020
		sta $d021
		lda #200
		sta $d016
		lda #$fc
		sta $d030		;C128
		.if (SECOND_SID >> 8)=$d6
		lda $d030		;C128?
		lsr
		bcc +
		.fi
		stx SECOND_SID+$18	;Second SID
+		lda #22
		sta $d018
		lda #27
		sta $d011
		sei
		lda #$37
		sta $01
		lda #$2f
		sta $00

                .comment
		ldx #7
-		lda de60txt,x
		sta $450,x
		dex
		bpl -

		ldx #$60
dtp		lda $9e00,x
		cmp $de00,x
		beq ti

-		inc $d856
		lda #"!"
		sta $456
		gne -

ti		inx
		bne dtp

		lda #122
		sta $456
                .endc

		bit $d0bc
		bpl scpuskip

		ldx #9-3
-		lda extramtxt,x
		sta $478+3,x
		dex
		bpl -

		sta cfg_open
                #assert_cfg_open
llp		lda $480
		tax
		asl
		jsr extramtest
                bcc sds

-		inc $d8d0
		lda #"!"
		sta $480
                gne -

sds		inc $480
		lda $480
		cmp #19
		bcc llp

		lda #122
		sta $480

		#assert_8000romioonly
scpuskip	sta cfg_16
		#assert_cfg_16

		ldx #9-3
-		lda extromtxt,x
		sta $4a0+3,x
		dex
		bpl -

re		jsr romtest
		beq kc2

-		inc $d8f8
		ldy #"!"
		sty $4a8
		gne -

kc2		dec $4a8
		bne re

		lda #122
		sta $4a8

                .comment
		ldx #9
-		lda nvramtxt-1,x
		sta $4c8-1,x
		dex
		bne -
                stx kill_port

		lda #%11111111		;read ram burst command
		jsr cmos_start
                ldx #31
-               jsr cmos_read_byte	;read byte from RAM
		sta $27,x		;backup
                dex
                bne -
                stx kill_port

		lda #0
		sta $3
                clc
                jsr cmos_wp

lp3		lda #31
		sta $2
		lda #%11111110		;data write brust
		jsr cmos_start
		ldx $3
-		lda testpattern,x
		bne +
		ldx #255
+		inx
		jsr cmos_send_byte
		dec $2
		bne -
		ldx #$00		;reset
		stx kill_port

		lda #31
		sta $2
		lda #%11111111		;read ram burst command
		jsr cmos_start
		ldx $3
lp		jsr cmos_read_byte	;read byte from RAM
		cmp testpattern,x
		beq tk
		ldx #0
		stx kill_port
		geq er

tk		lda testpattern,x
		bne +
		ldx #255
+		inx
		dec $2
		bne lp
		ldx #$00		;reset
		stx kill_port

		inc $3
		lda $3
		cmp #19
		bcc lp3

		lda #122
		.byte $2c
er		lda #"!"
		sta $4cf

		lda #%11111110		;write ram burst command
		jsr cmos_start
                ldx #31
-               lda $27,x		;backup
                jsr cmos_send_byte
		dex
                bne -
                stx kill_port
                .endc

		.comment
		ldx #8
li8		lda clocktxt,x
		sta $4f0,x
		dex
		bpl li8

		jsr cmos_readsec
                and #$7f
                sta $28

                lda #%10000000
                jsr cmos_start
                lda $28
                jsr cmos_send_byte
                sta kill_port
                sec
                jsr cmos_wp

dr              bit $d011
                bpl dr
-               bit $d011
                bmi -
                dec $4f7
                bne dr

		jsr cmos_readsec
                eor $28
                beq er2

		lda #122
		.byte $2c
er2     	lda #"!"
		sta $4f7
                .endc

                .comment
		ldy #7
-	     	lda de32txt,y
		sta $518,y
		dey
		bpl -

		ldx #de32tstend-de32tst
-               lda de32tst-1,x
                sta $01,x
                dex
                bne -

                bit set_v
                ldy #3
                jsr $2
                bvc +

		lda #122
		.byte $2c
+	   	lda #"!"
		sta $51e
                .endc

;		ldx #7
;-		lda killtxt,x
;		sta $540,x
;		dex
;		bpl -
;
;		ldx #killtstend-killtst
;-               lda killtst-1,x
;                sta $01,x
;                dex
;                bne -
;
;                ldx #$60
;-               lda $9e00,x
;                sta $00,x
;                inx
;                bne -
;
;		ldx #$60
;                lda #1
;set_v		jmp $2
set_v           jmp *

;------------------------
;killtst
;		.logical $2
;                sta kill_port
;-		lda $00,x
;                cmp $de00,x
;                bne +
;                inx
;                bne -
;
;		lda #"!"
;		.byte $2c
;+	   	lda #122
;		sta $546
;
;                jmp *
;		.here
;killtstend
;------------------------
;de32tst
;		.logical $2
;js		sta bank_port0,y
;		ldx #3
;js2		sta cfg_16,x
;		tya
;                asl
;                asl
;		eor $de32
;                and #$0f
;                eor de32const,x
;                beq +
;                clv
;+               dex
;                bpl js2
;                dey
;                bpl js
;                rts
;
;de32const	.byte $00,$02,$01,$03
;		.here
;de32tstend
;------------------------
                .comment
cmos_wp		php
		lda #%10001110  	;disable write protect
		jsr cmos_start
                plp
                ror
                jsr cmos_send_byte
                sta kill_port
                rts

cmos_start	ldx #$02
		stx kill_port		;UNreset
cmos_send_byte	jsr +
+		jsr +
+		jsr +
+		sta clock_port		; bit 0
		lsr a
		rts

cmos_read_byte	jsr +
+		jsr +
+		jsr +
+		lda clock_port		; bit 1
		lsr a
		tya
		ror a
		tay
		rts

cmos_readsec   	lda #%10000001  	;read clock burst command
cmos_read      	jsr cmos_start
                jsr cmos_read_byte
                ldx #0
                stx kill_port
                rts
                .endc
;------------------------
		#assert_8000romonly

		.enc screen
;de60txt		.text "DE60 [",32,"]"
;extramtxt	.text "EXTRAM [",255,"]"
;extromtxt	.text "EXTROM [",20,"]"
extramtxt	.text "RAM [",255,"]"
extromtxt	.text "ROM [",20,"]"
;nvramtxt	.text "NVRAM [",32,"]"
;clocktxt	.text "CLOCK [",70,"]"
;de32txt		.text "DE32 [",32,"]"
;killtxt		.text "KILL [",32,"]"
		.enc none

testpattern	.byte %10000000		;1
		.byte %01000000		;2
		.byte %00100000		;3
		.byte %00010000		;4
		.byte %00001000		;5
		.byte %00000100		;6
		.byte %00000010		;7
		.byte %00000001		;8
		.byte %11111111		;9
		.byte %01111111		;10
		.byte %10111111		;11
		.byte %11011111		;12
		.byte %11101111		;13
		.byte %11110111		;14
		.byte %11111011		;15
		.byte %11111101		;16
		.byte %11111110		;17
		.byte %01010101		;18
		.byte %00000000		;19
		.pend
mtestend

cable_pattern  	.byte 0,0,0,0,255,255,255,255,0,255,0,255,255,0

		#assert_cfg_16
romtest		.proc
		ldx #rtestend-rtest
-		lda rtest-1,x
		sta $101-1,x
		dex
		bne -

		clc
		txa
		jsr $101

                sec
		sbc chksum
		bcs +
		dex
                sec
+		sbc chksum+1
		bcs +
                dex
+
		cmp chksum
		bne +
		cpx chksum+1
+		rts

rtest		.logical $101
bnk		sta bank_port3
		ldy #$bf
		sty icr+2
		sty hb2+2
lp		ldy #0
icr		adc $8000,y
		bcc hb2
                clc
		inx
hb2		adc $8080,y
		bcc +
                clc
		inx
+		iny
		bpl icr
		dec icr+2
		dec hb2+2
		bmi lp
		dec bnk+1
		dec k
		bne bnk
		rts
k               .byte 4
		.here
rtestend

		.pend

		#assert_cfg_open
extramtest	.proc
		ldy #rtestend-rtest
dg		lda rtest-1,y
		sta $101-1,y
		dey
		bne dg

		lda #$10
		sta u+2
		sta uu+2
                jmp $101

rtest		.logical $101
		bcc nni
                lda #$f4
                sta at+1
		inx
		geq vv2

nl2		tax
		geq u2

nni		lda selftest.testpattern,x
		bne +
                ldx #255
+		inx
u		eor $ff00,y
	        bne merror2
vv2		lda selftest.testpattern,x
uu		sta $ff00,y
                beq nl2
                inx
u2		iny
at		bne u
		inc $d020
                dec $d020
		inc u+2
		inc uu+2
		bpl u
                clc
                rts
merror2		bcs vv2
		sec
                rts
                .here
rtestend
		.pend
                .cpu default

		#assert_cfg_open
transfer_test   .proc
		#stz_a pom1

test            jsr OP_get_current_drive_type
		beq ok		;no drive
                bmi ok		;non ata

                lda #write_buffer_d
		ldy #1
                jsr ata_data_commandany
                bcs err2
                ldy #0
                ldx pom1
kd              lda cable_pattern-19+1,x
                sta hig_reg
                lda cable_pattern-19,x
		#sta_low_reg
                sta data_g
                lda cable_pattern-19+3,x
                sta hig_reg
                lda cable_pattern-19+2,x
		#sta_low_reg
                sta data_g
                iny
                bpl kd
                jsr wait_busy
                bcs err;                jsr ata_pi_nomore_data;                bcs err

		lda #read_buffer_d
                ldy #1
                jsr ata_data_commandany
                bcs err2
                ldy #0
                ldx pom1
kd2             lda data_g
		#lda_low_reg
                eor cable_pattern-19,x
                bne kk
                lda hig_reg
                eor cable_pattern-19+1,x
                beq +
kk              sec
+               lda data_g
		#lda_low_reg
                eor cable_pattern-19+2,x
                bne kkk
                lda hig_reg
                eor cable_pattern-19+3,x
                beq +
kkk		sec
+		iny
                bpl kd2
                bcs err
                jsr wait_busy
                bcs err;                jsr ata_pi_nomore_data;                bcs err
		inc pom1
                lda pom1
                cmp #11+19
                bcc test
ok              clc
		rts

err2		lda pom1
		beq ok
err		lda #76+$80
		gne seterrorpos

		.pend
